MODULE Cookie;
(* The Cookie program, Source (C) Marco van de Voort,
  sources Cookie-Project are part of the XTDLIB package.

V1.02 : NEW STRUCTURES! Old CDX and CAF's not compatible any more.
(Old CAFS might contain bugs which confuse new CAF indexing routines)
CDX format is totally different.

Extracts a random joke from a CAF each time it's run.

Starts to mature now.

*)

IMPORT FIO,IO;

FROM Lib      IMPORT RANDOMIZE,CommandLine;
FROM SYSTEM   IMPORT Eval;
FROM Str      IMPORT Copy,RCharPos,Append,ItemS,Slice,CharPos,Caps,Delete,ItemS;

FROM DJArc    IMPORT Unpacker;
FROM ELib     IMPORT ChangeExtension,GetSwitch,LTrim;
FROM MLib     IMPORT Random32,FindInPath;
FROM CoreEFIO IMPORT Rd16,Rd32;

FROM CookShr  IMPORT ReadAndOutputJoke,Hdr,BaseRecord,HdrRecord,Buffer,
                     BufferP,ReadTable2,IndTab1,IndTab2,InitCDX,NoOutput,
                     CheckForRebuild,CategRec,CountNumber,Count2RecNr,
                     DoConfigLine;

CONST CrLf=CHR(13)+CHR(10);

Usage=CrLf+
"Cookie v1.02 By Marco van de Voort (C) 1998 E-Mail: Marcov@stack.nl"+CrLf+CrLf+
" displays a joke or quote, everytime it's run."+CrLf+CrLf+
"Usage : Cookie [CAF-file]"+CrLf+CrLf+
" Cookie without parameters searches for a *.CAF in the DOS-path If you"+CrLf+
" wish to use a different *.caf file, you can specify it's location"+CrLf+
"  as a parameter e.g. Cookie C:\dos\use_this.caf"+CrLf+CrLf+
" -V Cookie is pretty silent. If you want to see some internal messages about"+CrLf+
"    what it's doing, which CAF-file Cookie used etc, use this parameter"+CrLf+ CrLf+
" -R forces Cookie to rebuild the CDX files. Just in case they get messed up."+CrLf+CrLf+
" -I Neglect Cookie.cfg, all jokes are selectable."+CrLf+CrLf+
" -O If offensive joke file is configured in Cookie.Cfg, use this file."+CrLf+
"    If not, same as -I"+CrLf+CrLf+
" -C:CfgName.cfg Use CfgName.Cfg instead of cookie.cfg"+CrLf;

CookConfName="Cookie.cfg";

VAR       First       : BOOLEAN;
          Cat         : CategRec;
          DefFile,
          OffFile     : FIO.PathStr;

PROCEDURE ReadConfig(VAR S : ARRAY OF CHAR);

VAR F : FIO.File;
    A : CARDINAL;
    S2 : FIO.PathStr;

BEGIN
 DefFile[0]:=CHR(0); OffFile[0]:=CHR(0);
 FOR A:=0 TO 27 DO
  Cat.High[A]:=9;
  END;
 IF S[0]=CHR(0) THEN
  IF FIO.Exists(CookConfName) THEN
   Copy (S,CookConfName);
  ELSE
   FindInPath(CookConfName,S);
   END;
  END;
 IF FIO.Exists(S) THEN
 F:=FIO.Open(S);
 LOOP
  FIO.RdStr(F,S);
  IF FIO.EOF THEN
   EXIT
   END;
  A:=CharPos(S,";");
  IF A#MAX(CARDINAL) THEN   (* Cut comment*)
   S[A]:=CHR(0);
   END;
  LTrim(S," ");
  Caps(S);
  IF (S[0]="B") AND (S[1]="L") THEN            (* SPEC *)
    A:=CharPos(S," ");
    IF A # MAX(CARDINAL) THEN
    Delete(S,0,A+1);
    END;
    LTrim(S," ");
    DoConfigLine(S,Cat);
   ELSIF (S[0]="D") AND ((S[1]="E") AND (S[2]="F")) THEN
    ItemS(DefFile,S,'" ',1);
   ELSIF (S[0]="O") AND ((S[1]="F") AND (S[2]="F")) THEN
    ItemS(OffFile,S,'" ',1);
   ELSE
    IF S[0] # CHR(0) THEN
     IO.WrStr(" Error in config file "); IO.WrLn;
     HALT;
     END;
    END;
  END; (* Loop *)
 FIO.Close(F);
  END;
END ReadConfig;

PROCEDURE ReadNdx(Name:ARRAY OF CHAR):CARDINAL;

VAR
    A    : CARDINAL;
    Search  : LONGCARD;
    C,
    D,DPos  : LONGCARD;
    Found   : BOOLEAN;
    HdrF    : FIO.File;

BEGIN
 Cat.Low[27]:=30;
 IF NOT NoOutput THEN
  IO.WrStr("Using CAF : "); IO.WrStr(Name); IO.WrLn; IO.WrLn;
  END;
 A:=InitCDX(Name,HdrF);
 D:=CountNumber(HdrF,Cat);      (* Get Number of files in category selected*)
 IF D=0 THEN
  FIO.Close(HdrF);
  IO.WrStr("No jokes in current selection!");  IO.WrLn;
  HALT;
  END;
 Search:=Random32(D);           (* Pick one randomly *)
 Search:=Count2RecNr (HdrF,Cat,Search); (* Transform back to real index *)

 ReadTable2(HdrF,Search,D,A);   (* Transform index to blocknrfileposition
                                    and index in block *)
 FIO.Close(HdrF);               (* Then done with indexfile *)
 RETURN ReadAndOutputJoke(Name,A,D); (* Joke to screen and end *)
END ReadNdx;

VAR Path,SearchName,
    Predef          : ARRAY[0..127] OF CHAR;
    D               : FIO.DirEntry;
    A               : CARDINAL;
    AutoRebuild     : BOOLEAN;
    EraseCat        : BOOLEAN;
    Offens          : BOOLEAN;

BEGIN
 FIO.ShareMode:=FIO.ShareDenyWR;
 RANDOMIZE; First:=TRUE; AutoRebuild:=FALSE; EraseCat:=FALSE;
 Copy(Path,CommandLine^);
 Predef[0]:=CHR(0);
 WHILE GetSwitch(Path,SearchName,"-") DO
  CASE CAP(SearchName[0]) OF
   | "V" : NoOutput:=FALSE;
   | "?" : IO.WrStr(Usage); IO.WrLn; HALT;
   | "R" : AutoRebuild:=TRUE;
   | "C" : Delete(SearchName,0,2);
           IF FIO.Exists(SearchName) THEN
            Copy(Predef,SearchName);
            END;
   | "I" : EraseCat:=TRUE;
   | "O" : Offens:=TRUE;
   END;
  END;
 IF NOT NoOutput THEN
  IO.WrStr("Cookie 1.02, (C) Marco van de Voort"); IO.WrLn; IO.WrLn;
  END;
 ReadConfig(Predef);
 IF EraseCat OR Offens THEN
  FOR A:=0 TO 27 DO
   Cat.High[A]:=9;   Cat.Low[A]:=0;
   END;
  END;
 ItemS(SearchName,Path," ",0);
 IF NOT FIO.Exists(SearchName) THEN (* If I can't find the file rightaway *)
  IF DefFile[0]#CHR(0) THEN         (* Check if there are defaults*)
   Copy(SearchName,DefFile);
   END;
  IF Offens AND (OffFile[0]#CHR(0)) THEN
   Copy(SearchName,OffFile);
   END;
  END;


 IF SearchName[0]=CHR(0) THEN
  SearchName:="*.caf";
  END;
 IF FIO.ReadFirstEntry(SearchName,FIO.FileAttr{FIO.directory},D) THEN
  (* Argument a directory?*)
  IF FIO.directory IN D.attr THEN
   Append(SearchName,"\*.CAF");
   END;
  END;
 IF RCharPos(SearchName,"*") # MAX(CARDINAL) THEN
  A:=RCharPos(SearchName,"\");
  IF A= MAX(CARDINAL) THEN
   Copy(Path,SearchName);
  ELSE
   Slice(Path,SearchName,0,A+1);
   END;
  IF FIO.ReadFirstEntry(SearchName,FIO.FileAttr{},D) THEN
   REPEAT
    Copy(SearchName,Path);
    Append(SearchName,D.Name);
    CheckForRebuild(SearchName,AutoRebuild);
    UNTIL NOT FIO.ReadNextEntry(D);
   END;
 ELSE
  IF RCharPos(SearchName,".") = MAX(CARDINAL) THEN
   Append(SearchName,".CAF");
   END;
  IF FIO.Exists(SearchName) THEN
   CheckForRebuild(SearchName,AutoRebuild);
   END;
  END;

  IF FIO.Exists(SearchName) THEN
   IF ReadNdx(SearchName)=2 THEN
    CheckForRebuild(SearchName,AutoRebuild);
    Eval(ReadNdx(SearchName));
    END;
  ELSE
   FindInPath("*.caf",SearchName);
   IF FIO.Exists(SearchName) THEN
    CheckForRebuild(SearchName,AutoRebuild);
    Eval(ReadNdx(SearchName));
   ELSE
    IO.WrStr("File not found"+CrLf);
    IO.WrStr(Usage);
    END;
   END;
END Cookie.