IMPLEMENTATION MODULE WinProc;

FROM Window  IMPORT TextColor,TextBackground,GotoXY,Color,CursorOn,CursorOff;
FROM Str     IMPORT Copy,Length,ItemS;
FROM ELib    IMPORT GetKey,StrStr;
FROM Lib     IMPORT ScanR;
FROM IO      IMPORT WrChar,WrCharRep;
FROM CoreCrt IMPORT SetCurSize;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
IMPORT       Window,Str,IO;

(* Keyconstants used *)
CONST   Space = 20H;     Tilde = 7EH;     BS=8;            CtrlY = 19H;
        ESC = 1BH;       Home   = 04700H; ArrU   = 04800H; PgUp   = 04900H;
        ArrL   = 04B00H; ArrR   = 04D00H; End    = 04F00H; ArrD   = 05000H;
        PgDn   = 05100H; Insert = 05200H; Delete = 05300H; CR=13;
        F1  = 3B00H;     CtrlT  = 14H;

(* Generic routines *)

VAR ins : BOOLEAN;

PROCEDURE OutputStr(S:ARRAY OF CHAR;X,Y,XLength:CARDINAL;AColor:BYTE);

BEGIN
 TextColor(Color(AColor));GotoXY(X,Y);IO.WrStr(S);
END OutputStr;

PROCEDURE SetAttrs(Col : BYTE);
BEGIN
 TextColor(Color(ORD(Col) AND 15));
 TextBackground(Color((ORD(Col)>>4)));
END SetAttrs;



PROCEDURE InputStr(VAR S:ARRAY OF CHAR;X,Y,Len:CARDINAL;Flag:BOOLEAN;Toegest:CHARSET):BOOLEAN;

(* Since I'm in a hurry, I'll only translate the procedure heading:

  Input a string from keyboard, in a nice way,
   allowed characters are in CHARSET D.Toegestaan, but several editting
   keys are always allowed, see CASE loop.

Theoretical limit of 80 characters, but this isn't tested, so you could reach
132 characters if you wish, but you'll have to make "UitG" bigger.

Parameters:

   X,Y Coordinates field
   Len   Lengte field
   Flags   Extra data:
         0 "S" is not empty and contains a default string
         1 Insert is on. *)

VAR
    InGev                     : CARDINAL; (* No. of chars inputted *)
    Posi                      : CARDINAL; (* Cursorposition*)
    Ins                       : BOOLEAN;  (* Insert yes/no *)
    Key                       : CARDINAL; (* Last key as ELib.GetKey
    				              code <255 if normal key,
    				                   >256 if special/function
    				                   key. See header TLIB.DEF*)
    Uitg                      : ARRAY[0..81] OF CHAR; (* The inputted string*)
    Full                      : BOOLEAN;   (* Is the string full? *)

    I                         : CARDINAL;  (* Temporary variabele *)


PROCEDURE ReWr(); (* Rewrite the field, using Uitg*)

BEGIN
 Str.Delete(Uitg,Len,Length(Uitg));
 IF Length(Uitg)>0 THEN
  FOR I:= 0 TO Length(Uitg)-1 DO
   GotoXY(X+I,Y);
   IF Uitg[I]=CHR(32) THEN
    WrChar(CHR(FieldSpace));
   ELSE
    WrChar(Uitg[I]);
    END;
   END;
  END;
 GotoXY(X+Length(Uitg),Y);
 WrCharRep(CHR(FieldSpace),Len-Length(Uitg));
END ReWr;

PROCEDURE DoCursor; (* Put Cursor in/out insert-mode *)

BEGIN
 IF Ins=TRUE THEN
  SetCurSize(1,30);
 ELSE
  SetCurSize(7,30);
  END;
END DoCursor;

BEGIN
    (* Init *)

  InGev :=0;	 	   (* 0 chars untill now *)
  Posi  :=0;               (* Cursorposition 0 *)
  Ins   :=TRUE;            (* Insert according to parameters *)
  DoCursor;		   (* Set cursor accordingly *)
  Key   :=0;

       (* put  padded field on screen *)

  StrStr(Uitg,CHR(FieldSpace),Len);
  ReWr;
  GotoXY(X,Y);

  StrStr(Uitg,CHR(0),80);                  (* Empty Uitg entirely *)

  IF Flag=TRUE THEN
   Str.Concat(Uitg,S,"");
   Posi:=Length(S);                        (* Put a predefined *)
   ReWr;                                   (*  String on screen if specified *)
   END;


  LOOP
   Full:=FALSE;

   IF ((Posi+1)>Len) THEN
    Full:=FALSE;
    Posi:=Len-1;
    END;

   GotoXY(X+Posi,Y);
   CursorOn;
   DoCursor;
   Key:=GetKey();
   CursorOff;
   CASE Key OF
    |      CR              : Str.Concat(S,Uitg,"");        (*Type conversion, *)
                             RETURN TRUE;      (* I had problems with Str.Copy*)
    |      ESC             : RETURN FALSE;
    |      BS              : IF NOT (Posi=0) THEN       (* BackSpace *)
                              DEC(Posi);
                              Str.Delete(Uitg,Posi,1);
                              DEC(InGev);
                              ReWr;
                              END;
    |      Delete          : Str.Delete(Uitg,Posi,1);
                             DEC(InGev);
                             ReWr;
    |      ArrR            : IF (NOT Full) AND (Posi<InGev) THEN
                              INC (Posi);
                              GotoXY(X+Posi,Y);
                              END;
    |      Insert          : Ins:= NOT Ins;
                             DoCursor;
    |      ArrL            : IF (NOT (Posi=0)) THEN
                              DEC (Posi);
                              GotoXY(X+Posi,Y);
                              END;
    |      Home            : Posi:=0;
    |      End             : Posi:=InGev-1;
    |      CtrlY           : Str.Delete(Uitg,Posi+1,Length(Uitg)-Posi-1);
                             ReWr;
    |      CtrlT           : Uitg:="";Posi:=0; ReWr;
    END;
   IF (CHR(Key) IN Toegest) AND (Full=FALSE)THEN
    IF Ins=FALSE THEN
     Uitg[Posi]:=CHR(Key);
    ELSE
     Str.Insert(Uitg,CHR(Key),Posi);	
     END;
    ReWr;
    INC(Posi);
    END;
   IF InGev<Posi THEN
    InGev:=Length(Uitg);
    END;
   END;
END InputStr;


PROCEDURE Selector( Display : ProcD; MaxLines, Lines : CARDINAL; VAR First, Curr : CARDINAL ) : CARDINAL;
VAR
   Key, Entry : CARDINAL;

   PROCEDURE DisplayLines( First, Lines : CARDINAL );
   VAR
      Line : CARDINAL;
   BEGIN
      FOR Line := First TO First+Lines-1 DO
       IF Line<=MaxLines THEN
         Display( Line, Line-First, NormalColor );
         END;
      END;
   END DisplayLines;

BEGIN
   CursorOff;
   IF Curr > (First+Lines-1) THEN
    First := Curr-Lines+1;
    END;
   DisplayLines( First, Lines );
   Entry := Curr;
   LOOP
      Display( Entry, Entry-First, HilightColor );
      Key := GetKey();
      Display( Entry, Entry-First, NormalColor );
      CASE Key OF
      | ArrD : IF Entry < MaxLines THEN
                  INC( Entry );
               ELSE
                  Entry := 1;
               END;
      | ArrU : IF Entry > 1 THEN
                  DEC( Entry );
               ELSE
                  Entry := MaxLines;
               END;
      | PgDn : IF Entry < First+Lines-1 THEN
                  Entry := First+Lines-1;
                  IF Entry > MaxLines THEN
                     Entry := MaxLines;
                  END;
               ELSIF Entry+Lines > MaxLines THEN
                  Entry := MaxLines;
               ELSE
                  INC( Entry, Lines );
               END;
      | PgUp : IF Entry > First THEN
                  Entry := First;
               ELSIF INTEGER(Entry)-INTEGER(Lines) < 1 THEN
                  Entry := 1;
               ELSE
                  DEC( Entry, Lines );
               END;
      | Home : Entry := 1;
      | End  : Entry := MaxLines;
(*      | Insert, Delete, CR, F1 :
               Curr := Entry;
               EXIT; *)
      | ESC  :  Curr := 0;
                EXIT;
               ELSE
                Curr := Entry;
                EXIT;
                END;
      IF Entry < First THEN
         First := Entry;
         DisplayLines( First, Lines );
      ELSIF Entry > First+Lines-1 THEN
         First := Entry-Lines+1;
         DisplayLines( First, Lines );
      END;
   END;
   SetCurSize(6,7);
   RETURN Key;
END Selector;

PROCEDURE EditRecord( VAR Edit:EditRec; MaxField : CARDINAL;Rec:CARDINAL );
VAR
   Key, Field : CARDINAL;
   WD         : Window.WinDef;
   Win        : Window.WinType;

BEGIN
   WD.X1:=Edit.X1;               WD.Y1:=Edit.Y1;
   WD.X2:=Edit.X2;               WD.Y2:=Edit.Y2;
   WD.Background:=Edit.BackCol;  WD.Foreground:=Edit.ForeCol;
   WD.CursorOn:=FALSE;           WD.WrapOn:=FALSE;
   WD.Hidden:=FALSE;             WD.FrameOn:=Edit.Frame;
   IF Edit.Frame THEN
    WD.FrameDef :=Edit.FrameType; WD.FrameFore:=Edit.ForeFrame;
    WD.FrameBack:=Edit.BackFrame;
    END;
   Win:=Window.Open(WD);
   Window.Use(Win);
   CursorOff;
   Edit.InitEdit;
   FOR Field := 1 TO MaxField DO
    Edit.DisplEdit( Field, Rec, NormalColor );
    END;
   Field := 1;
   LOOP
      Edit.DisplEdit( Field, Rec, HilightColor );
      Key := GetKey();
      Edit.DisplEdit( Field, Rec, NormalColor );
      CASE Key OF
      | ArrD : IF Field < MaxField THEN
                  INC( Field );
               ELSE
                  Field := 1;
               END;
      | ArrU : IF Field > 1 THEN
                  DEC( Field );
               ELSE
                  Field := MaxField;
               END;
      | PgDn : Field := MaxField;
      | PgUp : Field := 1;
      | CR   : Edit.EditField( Field,Rec );
      | ESC  : EXIT;
      END;
   END;
   SetCurSize(6,7);
   Window.Close(Win);
END EditRecord;

PROCEDURE Toggler(VAR Value : BYTE;String : ARRAY OF CHAR;Increment:BOOLEAN);

VAR SubStr : ARRAY[0..40] OF CHAR;

BEGIN
 IF Increment THEN
  Value:=(Value+BYTE(1)) MOD BYTE(String[0]);
  END;
 ItemS(SubStr,String,"@",CARDINAL(Value));
 IF Value=BYTE(0) THEN
  Str.Delete(SubStr,0,1);
  END;
 IO.WrStr(SubStr);
END Toggler;

PROCEDURE EditArray(VAR R : SelectEditRec;VAR Edit :EditRec;VAR NrRec:CARDINAL);

VAR First,CRec,
    Key       : CARDINAL;
    Win       : Window.WinType;
    WD        : Window.WinDef;

BEGIN
 WD.X1:=R.X1;               WD.Y1:=R.Y1;
 WD.X2:=R.X2;               WD.Y2:=R.Y2;
 WD.Background:=R.BackCol;  WD.Foreground:=R.ForeCol;
 WD.CursorOn:=FALSE;        WD.WrapOn:=FALSE;
 WD.Hidden:=FALSE;          WD.FrameOn:=R.Frame;
 IF R.Frame THEN
  WD.FrameDef:=R.FrameType; WD.FrameFore:=R.ForeFrame;
  WD.FrameBack:=R.BackFrame;
  END;
 CursorOff;
 Win:=Window.Open(WD);
 Window.Use(Win);
 R.BackGrProc;
 First:=1;
 CRec:=First;
 WITH R DO
   LOOP
      Key := Selector(DisplLine, NrRec, R.VisLines, First, CRec);
      CASE Key OF
       | CR     : EditRecord( Edit, R.Fields ,CRec);
                  Window.Use(Win);
       | Delete : IF DelRecProc # NULLPROC THEN
                   DelRecProc( CRec, NrRec );
                   END;
       | Insert : IF NrRec<R.MaxRec THEN
                   IF InsRecProc # NULLPROC THEN
                    InsRecProc( CRec, NrRec );
                    EditRecord( Edit, R.Fields,NrRec );
                    Window.Use(Win);
                    CRec:=NrRec;
                    END;
                   END;
       | ESC    : EXIT;
      ELSE
       IF ElseProc # NULLPROC THEN
        ElseProc(Key,CRec,NrRec);
        END;
      END;
   END;
 END;
 Window.Close(Win);
 CursorOn;
END EditArray;


(* --------     Screen setup system -------- *)
PROCEDURE InitBigStr(TS : InBigPtr):PBackGrType;

VAR SysDat : PBackGrType;
    Nr     : CARDINAL;
    Ind    : CARDINAL;

BEGIN
 NEW(SysDat);
 SysDat^.Data:=TS;
 Nr:=0; Ind:=0;
 LOOP
  IF TS^[Ind]=CHR(0) THEN
   EXIT
   END;
  SysDat^.Indices[Nr]:=Ind;
  INC(Nr);
  INC(Ind);    INC(Ind);
  INC(Ind);    INC(Ind);
  IF Ind>HIGH(TS^) THEN  (* safety *)
   EXIT
   END;
  Ind:=Ind+ScanR(ADR(TS^[Ind]),HIGH(TS^)-Ind,0)+1;
  END;
 SysDat^.Items:=Nr;
 RETURN SysDat;
END InitBigStr;

PROCEDURE KillBigStr(VAR TS : PBackGrType);
BEGIN
 DISPOSE(TS);
END KillBigStr;

PROCEDURE GetStrPtr(TS: PBackGrType;NrFoc : CARDINAL):InBigPtr;

BEGIN
 RETURN InBigPtr (ADR(TS^.Data^[TS^.Indices[NrFoc]]));
END GetStrPtr;

PROCEDURE BuildScreenFromPtr(TS:PBackGrType);

VAR A : CARDINAL;
    P : InBigPtr;

BEGIN
 FOR A:=0 TO TS^.Items-1 DO
  P:=GetStrPtr(TS,A);
  Window.GotoXY(ORD(P^[0]),ORD(P^[1]));
  SetAttrs(P^[3]);
  P:=ADR(P^[4]);
  IO.WrStr(P^);
  END;
END BuildScreenFromPtr;

BEGIN
   NormalColor  := ORD(LightGray)+ORD(Black)*16;
   HilightColor := ORD(Black)+ORD(White)*16;
   EditColor    := ORD(Yellow)+ORD(Green)*16;
   FieldSpace:=177;
END WinProc.