
MODULE DJArc2;
(*
 The original DJARC, maybe working, I don't have the commandline handlers*)

(*
FROM ArgHandler IMPORT
       argc,argv;
FROM Filenames IMPORT
       ParseFilename,MakeFilename;

IMPORT AsmLib,FileSystem,Storage,PRINTF,FIO,Strings,DJArcA;
  *)

FROM FormIO IMPORT WrF1,WrF,WrF3,WrF5,WrF4;
IMPORT FIO,Lib,Storage,Str,DJArcA;

(*
LZHUF.C (c)1989 by Haruyasu Yoshizaki, Haruhiko Okumura, and Kenji Rikitake.
All rights reserved. Permission granted for non-commercial use.
*)

(*
 * LZHUF.C English version 1.0
 * Based on Japanese version 29-NOV-1988
 * LZSS coded by Haruhiko OKUMURA
 * Adaptive Huffman Coding coded by Haruyasu YOSHIZAKI
 * Edited and translated to English by Kenji RIKITAKE
 * Translated to Modula-2 by Don Milne, June 1989.
 *)

CONST BUFFSIZE   = 10240;
      FIONULLFILE=MAX(CARDINAL);

TYPE CharPtr = POINTER TO ARRAY[0..1023] OF CHAR;

VAR infile,outfile: FIO.File;
    inp,inbytes,outp,ArcCRC:CARDINAL;
    codesize,textsize,BytesLeft:LONGCARD;
    input,output:ARRAY[0..BUFFSIZE-1] OF CHAR;
    CRCTable:ARRAY[0..255] OF BITSET;

(* LZSS Parameters *)

CONST  N            = 4096;    (* Size of string buffer *)
       F            = 60;      (* Size of look-ahead buffer *)
       THRESHOLD    = 2;
       NILPTR       = N;       (* End of tree's node  *)

VAR textbuf:ARRAY[0..N+F-1] OF CHAR;
    mpos,mlen:INTEGER;
    lson:ARRAY[0..N] OF INTEGER;
    rson:ARRAY[0..N+256] OF INTEGER;
    dad:ARRAY[0..N] OF INTEGER;

(* Huffman coding parameters *)

CONST NCHAR    = (256 - THRESHOLD + F); (* character code (= 0..NCHAR-1) *)
      T        = (NCHAR * 2 - 1);       (* Size of table *)
      R        = (T - 1);               (* root position *)
      MAXFREQ  = 8000H;                 (* update when cumulative frequency *)
                                        (* reaches this value *)

(* Tables FOR encoding/decoding upper 6 bits of
 * sliding dictionary pointer
 *)
(* encoder table *)
TYPE str64 = ARRAY[0..63] OF CHAR;
     str256 = ARRAY[0..255] OF CHAR;

CONST plen = str64(
        CHR(03H),CHR(04H),CHR(04H),CHR(04H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),
        CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),
        CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),
        CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),
        CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),
        CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),
        CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),
        CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H));

CONST pcode = str64(
        CHR(00H),CHR(020H),CHR(030H),CHR(040H),CHR(050H),CHR(058H),CHR(060H),CHR(068H),
        CHR(070H),CHR(078H),CHR(080H),CHR(088H),CHR(090H),CHR(094H),CHR(098H),CHR(09CH),
        CHR(0A0H),CHR(0A4H),CHR(0A8H),CHR(0ACH),CHR(0B0H),CHR(0B4H),CHR(0B8H),CHR(0BCH),
        CHR(0C0H),CHR(0C2H),CHR(0C4H),CHR(0C6H),CHR(0C8H),CHR(0CAH),CHR(0CCH),CHR(0CEH),
        CHR(0D0H),CHR(0D2H),CHR(0D4H),CHR(0D6H),CHR(0D8H),CHR(0DAH),CHR(0DCH),CHR(0DEH),
        CHR(0E0H),CHR(0E2H),CHR(0E4H),CHR(0E6H),CHR(0E8H),CHR(0EAH),CHR(0ECH),CHR(0EEH),
        CHR(0F0H),CHR(0F1H),CHR(0F2H),CHR(0F3H),CHR(0F4H),CHR(0F5H),CHR(0F6H),CHR(0F7H),
        CHR(0F8H),CHR(0F9H),CHR(0FAH),CHR(0FBH),CHR(0FCH),CHR(0FDH),CHR(0FEH),CHR(0FFH));

(* decoder table *)
CONST dcode = str256(
        CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),
        CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),
        CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),
        CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),CHR(00H),
        CHR(01H),CHR(01H),CHR(01H),CHR(01H),CHR(01H),CHR(01H),CHR(01H),CHR(01H),
        CHR(01H),CHR(01H),CHR(01H),CHR(01H),CHR(01H),CHR(01H),CHR(01H),CHR(01H),
        CHR(02H),CHR(02H),CHR(02H),CHR(02H),CHR(02H),CHR(02H),CHR(02H),CHR(02H),
        CHR(02H),CHR(02H),CHR(02H),CHR(02H),CHR(02H),CHR(02H),CHR(02H),CHR(02H),
        CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),
        CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),
        CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),
        CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),
        CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),
        CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),
        CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),
        CHR(09H),CHR(09H),CHR(09H),CHR(09H),CHR(09H),CHR(09H),CHR(09H),CHR(09H),
        CHR(0AH),CHR(0AH),CHR(0AH),CHR(0AH),CHR(0AH),CHR(0AH),CHR(0AH),CHR(0AH),
        CHR(0BH),CHR(0BH),CHR(0BH),CHR(0BH),CHR(0BH),CHR(0BH),CHR(0BH),CHR(0BH),
        CHR(0CH),CHR(0CH),CHR(0CH),CHR(0CH),CHR(0DH),CHR(0DH),CHR(0DH),CHR(0DH),
        CHR(0EH),CHR(0EH),CHR(0EH),CHR(0EH),CHR(0FH),CHR(0FH),CHR(0FH),CHR(0FH),
        CHR(010H),CHR(010H),CHR(010H),CHR(010H),CHR(011H),CHR(011H),CHR(011H),CHR(011H),
        CHR(012H),CHR(012H),CHR(012H),CHR(012H),CHR(013H),CHR(013H),CHR(013H),CHR(013H),
        CHR(014H),CHR(014H),CHR(014H),CHR(014H),CHR(015H),CHR(015H),CHR(015H),CHR(015H),
        CHR(016H),CHR(016H),CHR(016H),CHR(016H),CHR(017H),CHR(017H),CHR(017H),CHR(017H),
        CHR(018H),CHR(018H),CHR(019H),CHR(019H),CHR(01AH),CHR(01AH),CHR(01BH),CHR(01BH),
        CHR(01CH),CHR(01CH),CHR(01DH),CHR(01DH),CHR(01EH),CHR(01EH),CHR(01FH),CHR(01FH),
        CHR(020H),CHR(020H),CHR(021H),CHR(021H),CHR(022H),CHR(022H),CHR(023H),CHR(023H),
        CHR(024H),CHR(024H),CHR(025H),CHR(025H),CHR(026H),CHR(026H),CHR(027H),CHR(027H),
        CHR(028H),CHR(028H),CHR(029H),CHR(029H),CHR(02AH),CHR(02AH),CHR(02BH),CHR(02BH),
        CHR(02CH),CHR(02CH),CHR(02DH),CHR(02DH),CHR(02EH),CHR(02EH),CHR(02FH),CHR(02FH),
        CHR(030H),CHR(031H),CHR(032H),CHR(033H),CHR(034H),CHR(035H),CHR(036H),CHR(037H),
        CHR(038H),CHR(039H),CHR(03AH),CHR(03BH),CHR(03CH),CHR(03DH),CHR(03EH),CHR(03FH));

CONST dlen = str256(
        CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),
        CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),
        CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),
        CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),CHR(03H),
        CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),
        CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),
        CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),
        CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),
        CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),
        CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),CHR(04H),
        CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),
        CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),
        CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),
        CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),
        CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),
        CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),
        CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),
        CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),CHR(05H),
        CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),
        CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),
        CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),
        CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),
        CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),
        CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),CHR(06H),
        CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),
        CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),
        CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),
        CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),
        CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),
        CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),CHR(07H),
        CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),
        CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H),CHR(08H));

VAR freq:ARRAY[0..T] OF CARDINAL;   (* cumulative freq table *)

(*
 * pointing parent nodes.
 * area [T..(T + NCHAR - 1)] are pointers for leaves
 *)

VAR prnt:ARRAY[0..T + NCHAR] OF INTEGER;

(* pointing children nodes (son[], son[] + 1) *)
VAR son:ARRAY[0..T] OF INTEGER;
    code,len:CARDINAL;
    getbuf,putbuf:CARDINAL;
    getlen,putlen:SHORTCARD;

(**************************** UTILITY ROUTINES *****************************)

PROCEDURE Error(message:ARRAY OF CHAR);
BEGIN
     WrF1("\n%s\n",message);
     HALT (*EXITFAILED*);
END Error;

(*..............................................*)

PROCEDURE getc(VAR c:INTEGER):INTEGER;

VAR SizeToRead:CARDINAL;

BEGIN
     IF inp=inbytes THEN
         IF (FIO.EOF) OR (BytesLeft=0) THEN RETURN(-1) END;
         IF BytesLeft>BUFFSIZE THEN
             SizeToRead := BUFFSIZE
           ELSE
             SizeToRead := CARDINAL(BytesLeft);
         END;
         DEC(BytesLeft,LONGCARD(SizeToRead));
         inbytes := FIO.RdBin(infile,input,SizeToRead);
         inp := 0;
         IF inbytes = 0 THEN RETURN(-1) END;
     END;
     c := INTEGER(ORD(input[inp]));
     INC(inp);
     RETURN c;
END getc;

(*..............................................*)

PROCEDURE putc(c:INTEGER);
BEGIN
     output[outp] := CHR(CARDINAL(c)); INC(outp);
     IF outp=BUFFSIZE THEN
         FIO.WrBin(outfile,output,BUFFSIZE); outp:=0;
     END;
END putc;

(*..............................................*)

PROCEDURE getcupd(VAR c:INTEGER):INTEGER; (* as getc, but bump CRC accumulator *)

VAR x:INTEGER;

BEGIN
     IF getc(c)>=0 THEN
         ArcCRC := CARDINAL(CRCTable[CARDINAL((BITSET(ArcCRC)/BITSET(c))
                       * BITSET(0FFH))] / BITSET(ArcCRC>>8));
         RETURN c;
       ELSE
         RETURN -1;
     END;
END getcupd;

(*..............................................*)

PROCEDURE putcupd(c:INTEGER); (* as putc, but bump CRC accumulator *)
BEGIN
     putc(c);
     ArcCRC := CARDINAL(CRCTable[CARDINAL((BITSET(ArcCRC)/BITSET(c))
                   * BITSET(0FFH))] / BITSET(ArcCRC>>8));
END putcupd;

(*..............................................*)

(* initialize freq tree *)

PROCEDURE StartHuff();

VAR i,j:INTEGER;

BEGIN
     i:=0;
     WHILE i < NCHAR DO
         freq[i] := 1;
         son[i] := i + T;
         prnt[i + T] := i;
         INC(i);
     END;
     i := 0; j := NCHAR;
     WHILE (j <= R) DO
         freq[j] := freq[i] + freq[i + 1];
         son[j] := i;
         prnt[i] := j;
         prnt[i + 1] := j;
         INC(i,2); INC(j);
     END;
     freq[T] := 0FFFFH;
     prnt[R] := 0;
END StartHuff;

(************************ COMPRESSION ROUTINES ***************************)

PROCEDURE InitTree();  (* Initializing tree *)

VAR i:CARDINAL;

BEGIN
     i:=N+1;
     WHILE i<=N+256 DO rson[i]:=NILPTR; INC(i) END; (* root *)
     i:=0;
     WHILE (i<N) DO dad[i]:=NILPTR; INC(i) END;     (* node *)
END InitTree;

(*..............................................*)

PROCEDURE Putcode(l:INTEGER; c:CARDINAL);         (* output c bits *)
BEGIN
     putbuf := CARDINAL(BITSET(putbuf) + BITSET(c >> CARDINAL(putlen)));
     INC(putlen,SHORTCARD(l));
     IF putlen >= 8 THEN
         putc(putbuf >> 8);
         DEC(putlen,8);
         IF putlen >= 8 THEN
             putc(putbuf);
             INC(codesize,2);
             DEC(putlen,8);
             putbuf := c << (CARDINAL(l) - CARDINAL(putlen));
           ELSE
             putbuf := putbuf << 8;
             INC(codesize);
         END;
     END;
END Putcode;

(*..............................................*)

(* reconstruct freq tree *)

PROCEDURE reconst();

VAR i,j,k:INTEGER;
    f,l:CARDINAL;

BEGIN
     (* halven cumulative freq FOR leaf nodes *)
     i:=0; j:=0;
     WHILE i<T DO
         IF son[i] >= T THEN
             freq[j] := (freq[i] + 1) >> 1;
             son[j] := son[i];
             INC(j);
         END;
         INC(i);
     END;

     (* make a tree : first, connect children nodes *)
     i:=0; j:=NCHAR;
     WHILE j<T DO
         k := i + 1;
         f := freq[i] + freq[k];
         freq[j] := f;
         k:=j-1;
         WHILE f < freq[k] DO DEC(k) END;
         INC(k);
         l := (j - k) * 2;
         Lib.Move(ADR(freq[k]), ADR(freq[k+1]), l);
         freq[k] := f;
         Lib.Move(ADR(son[k]), ADR(son[k+1]), l);
         son[k] := i;
         INC(i,2); INC(j);
     END;

     (* connect parent nodes *)
     i:=0;
     WHILE i<T DO
         k := son[i];
         IF k >= T THEN
             prnt[k] := i;
           ELSE
             prnt[k] := i;
             prnt[k + 1] := i;
         END;
         INC(i);
     END;
END reconst;

(*..............................................*)

(* update freq tree *)

PROCEDURE update(c:INTEGER);

VAR i,j,k,l:INTEGER;

BEGIN
     IF freq[R] = MAXFREQ THEN reconst() END;

     c := prnt[c + T];
     REPEAT
           (* keep the outer loop together so stupid compilers
            * can optimize.
            *)
           LOOP
               INC(freq[c]); k:=freq[c];
               (* swap nodes to keep the tree freq-ordered *)
               IF CARDINAL(k) > freq[c + 1] THEN EXIT END;
               c := prnt[c];
               IF c=0 THEN RETURN END;
           END;

           l := c + 1;
           (* this is the inner loop -- unroll it a few times *)
           LOOP
               INC(l);
               IF CARDINAL(k)<=freq[l] THEN EXIT END;
           END;
           DEC(l);
           freq[c] := freq[l];
           freq[l] := k;

           i := son[c];
           prnt[i] := l;
           IF i < T THEN prnt[i + 1] := l END;

           j := son[l];
           son[l] := i;

           prnt[j] := c;
           IF j < T THEN prnt[j + 1] := c END;
           son[c] := j;

           c := l;
           c := prnt[c];
     UNTIL c=0;             (* do it until reaching the root *)
END update;

(*..............................................*)

PROCEDURE EncodeChar(c:CARDINAL);

VAR i:CARDINAL;
    j,k:INTEGER;

BEGIN
     i:=0; j:=0; k:=prnt[c + T];

     (* search connections from leaf node to the root *)
     REPEAT
           i := i>>1;
           (*
           IF node's address is odd, output 1
           ELSE output 0
           *)
           IF ODD(k) THEN INC(i,8000H) END;
           INC(j);
           k := prnt[k];
     UNTIL k = R;
     Putcode(j, i);
     code := i;
     len := j;
     update(c);
END EncodeChar;

(*..............................................*)

PROCEDURE EncodePosition(c:CARDINAL);

VAR i:CARDINAL;

BEGIN
     (* output upper 6 bits with encoding *)
     i := c >> 6;
     Putcode(INTEGER(ORD(plen[i])), ORD(pcode[i]) << 8);

     (* output lower 6 bits directly *)
     Putcode(6, CARDINAL(BITSET(c)*BITSET(3FH)) << 10);
END EncodePosition;

(*..............................................*)

PROCEDURE EncodeEnd();
BEGIN
     IF putlen<>0 THEN
         putc(putbuf >> 8);
         INC(codesize);
     END;
END EncodeEnd;

(*..............................................*)

(*
PROCEDURE InsertNode(r:INTEGER);  (* Inserting node to the tree *)

VAR i,p:INTEGER;
    c:CARDINAL;
    cmp:INTEGER;

BEGIN
     cmp := 1;
     p := N + 1 + INTEGER(textbuf[r]);
     rson[r] := NILPTR;
     lson[r] := NILPTR;
     mlen := 0;

     LOOP
         IF (cmp >= 0) THEN
             IF rson[p] <> NILPTR THEN
                 p := rson[p];
               ELSE
                 rson[p] := r;
                 dad[r] := p;
                 RETURN;
             END
           ELSIF (lson[p] <> NILPTR) THEN
             p := lson[p];
           ELSE
             lson[p] := r;
             dad[r] := p;
             RETURN;
         END;
         i:=1;
         LOOP
             IF i=F THEN EXIT END;
             cmp := INTEGER(textbuf[i+r])-INTEGER(textbuf[i+p]);
             IF cmp<>0 THEN EXIT END;
             INC(i);
         END;
         IF (i > THRESHOLD) THEN
             IF (i > mlen) THEN
                 mpos := INTEGER(BITSET(r-p) * BITSET(N-1)) - 1;
                 mlen := i;
                 IF mlen>=F THEN EXIT END;
               ELSIF i = mlen THEN
                 c := INTEGER(BITSET(r-p) * BITSET(N-1)) - 1;
                 IF c < CARDINAL(mpos) THEN mpos:=c END;
             END;
         END;
     END;

     dad[r] := dad[p];
     lson[r] := lson[p];
     rson[r] := rson[p];
     dad[lson[p]] := r;
     dad[rson[p]] := r;
     IF rson[dad[p]] = p THEN
         rson[dad[p]] := r;
       ELSE
         lson[dad[p]] := r;
     END;
     dad[p] := NILPTR;  (* remove p *)
END InsertNode;
*)

(*..............................................*)

PROCEDURE DeleteNode(p:INTEGER);  (* Deleting node from the tree *)

VAR q:INTEGER;

BEGIN
     IF dad[p] = NILPTR THEN RETURN END;  (* unregistered *)
     IF rson[p] = NILPTR THEN
         q := lson[p];
       ELSIF lson[p] = NILPTR THEN
         q := rson[p];
       ELSE
         q := lson[p];
         IF rson[q] <> NILPTR THEN
             REPEAT
                   q := rson[q];
             UNTIL rson[q] = NILPTR;
             rson[dad[q]] := lson[q];
             dad[lson[q]] := dad[q];
             lson[q] := lson[p];
             dad[lson[p]] := q;
         END;
         rson[q] := rson[p];
         dad[rson[p]] := q;
     END;
     dad[q] := dad[p];
     IF rson[dad[p]] = p THEN
         rson[dad[p]] := q;
       ELSE
         lson[dad[p]] := q;
     END;
     dad[p] := NILPTR;
END DeleteNode;

(*..............................................*)

PROCEDURE Encode();  (* Encoding/Compressing *)

VAR i,c,len,r,s,lastmatchlength:INTEGER;
    printcount:LONGCARD;

BEGIN
     textsize := 0;                   (* rewind and rescan *)
     printcount := 256;

     StartHuff();
     InitTree();
     s := 0;
     r := N - F;
     i:=s;
     WHILE i<r DO textbuf[i] := ' '; INC(i) END;
     len:=0;
     LOOP
         IF len>=F THEN EXIT END;
         IF getcupd(c)<0 THEN EXIT END;
         textbuf[r + len] := CHR(c);
         INC(len);
     END;
     i:=1; textsize:=LONGCARD(len);
     WHILE i<=F DO DJArcA.InsertNode(r - i); INC(i) END;
     DJArcA.InsertNode(r);
     REPEAT
           IF mlen > len THEN mlen := len END;
           IF mlen <= THRESHOLD THEN
               mlen := 1;
               EncodeChar(ORD(textbuf[r]));
             ELSE
               EncodeChar(255 - THRESHOLD + mlen);
               EncodePosition(mpos);
           END;
           i:=0; lastmatchlength:=mlen;
           LOOP
               IF i=lastmatchlength THEN EXIT END;
               IF getcupd(c)<0 THEN EXIT END;
               DeleteNode(s);
               textbuf[s] := CHR(c);
               IF (s < F - 1) THEN textbuf[s + N] := CHR(c) END;
               s := INTEGER(BITSET(s+1) * BITSET(N-1));
               r := INTEGER(BITSET(r+1) * BITSET(N-1));
               DJArcA.InsertNode(r);
               INC(i);
           END;
           INC(textsize,LONGCARD(i));

           IF (textsize > printcount) OR (c<0) THEN
               WrF1("%-7u\r", textsize);
               INC(printcount,256);
           END;

           LOOP
               IF i>=lastmatchlength THEN EXIT END;
               INC(i);
               DeleteNode(s);
               s := INTEGER(BITSET(s+1) * BITSET(N-1));
               r := INTEGER(BITSET(r+1) * BITSET(N-1));
               DEC(len);
               IF len<>0 THEN DJArcA.InsertNode(r) END;
           END;
     UNTIL len=0;
     EncodeEnd();
(*
     WrF1("input: %u bytes\n", textsize);
     WrF1("output: %u bytes\n", codesize);
     WrF1("output/input: %.3f\n", (double)codesize / textsize);
*)
END Encode;

(************************ DECOMPRESSION ROUTINES **************************)

PROCEDURE GetBit():INTEGER;        (* get one bit *)

VAR i:INTEGER;

BEGIN
     WHILE getlen <= 8 DO
         IF getc(i)<0 THEN i:=0 END;
         getbuf := CARDINAL(BITSET(getbuf) + BITSET(i << INTEGER(8 - getlen)));
         INC(getlen,8);
     END;
     i := getbuf;
     getbuf := getbuf << 1;
     DEC(getlen);
     RETURN ORD(INTEGER(i)<0);
END GetBit;

(*..............................................*)

PROCEDURE GetByte():INTEGER;      (* get a byte *)

VAR i:CARDINAL;
    temp:INTEGER;

BEGIN
     WHILE getlen <= 8 DO
         IF getc(temp)<0 THEN i:=0 ELSE i:=temp END;
         getbuf := CARDINAL(BITSET(getbuf) + BITSET(i << (8 - CARDINAL(getlen))));
         INC(getlen,8);
     END;
     i := getbuf;
     getbuf := getbuf<<8;
     DEC(getlen,8);
     RETURN (i >> 8);
END GetByte;

(*..............................................*)

PROCEDURE DecodeChar():INTEGER;

VAR c:CARDINAL;

BEGIN
     c := son[R];

     (*
      * start searching tree from the root to leaves.
      * choose node #(son[]) IF input bit = 0
      * ELSE choose #(son[]+1) (input bit = 1)
      *)
     WHILE c < T DO
         IF getlen<>0 THEN
             DEC(getlen);
             IF getbuf>=8000H THEN INC(c) END;
             getbuf := getbuf<<1;
           ELSE
             INC(c,GetBit());
         END;
         c := son[c];
     END;
     DEC(c,T);
     update(c);
     RETURN INTEGER(c);
END DecodeChar;

(*..............................................*)

PROCEDURE DecodePosition():INTEGER;

VAR i,j,c:CARDINAL;

BEGIN
     (* decode upper 6 bits from given table *)
     i := GetByte();
     c := ORD(dcode[i]) << 6;
     j := ORD(dlen[i]);

     (* input lower 6 bits directly *)
     DEC(j,2);
     WHILE j<>0 DO
         DEC(j);
         i := i<<1;
         IF getlen<>0 THEN
             DEC(getlen);
             IF getbuf>=8000H THEN INC(i) END;
             getbuf := getbuf<<1;
           ELSE
             INC(i,GetBit());
         END;
     END;
     RETURN INTEGER(BITSET(c)+(BITSET(i)*BITSET(3FH)));
END DecodePosition;

(*..............................................*)

PROCEDURE Decode(textsize:LONGCARD);  (* Decoding/Uncompressing *)

VAR i,j,k,r,c:INTEGER;
    count:LONGCARD;

BEGIN
     StartHuff();
     i:=0;
     WHILE i<N-F DO textbuf[i] := ' '; INC(i) END;
     count:=0; r:=N-F;
     WHILE count < textsize DO
         c := DecodeChar();
         IF c < 256 THEN
             putcupd(c);
             textbuf[r]:=CHR(c);
             r := INTEGER(BITSET(r+1) * BITSET(N-1));
             INC(count);
           ELSE
             i := INTEGER(BITSET(r-DecodePosition()-1) * BITSET(N-1));
             j := c - 255 + THRESHOLD;
             IF (r+j<N) AND (i+j<N) AND ((i+j<=r) OR (i>=r)) THEN
                 Lib.Move(ADR(textbuf[i]),ADR(textbuf[r]),j);
                 i:=r;
                 WHILE i<r+j DO
                     putcupd(INTEGER(ORD(textbuf[i]))); INC(i);
                 END;
                 INC(r,j);
                 INC(count,LONGCARD(j));
               ELSE
                 k:=i; INC(j,i);
                 WHILE k<j DO
                     c := ORD(textbuf[CARDINAL(BITSET(k)*BITSET(N-1))]);
                     putcupd(c);
                     textbuf[r] := CHR(c);
                     r := INTEGER(BITSET(r+1) * BITSET(N-1));
                     INC(count);
                     INC(k);
                 END;
             END;
         END;
         (*
         IF count > printcount THEN
             WrF1("%12u\r", count);
             INC(printcount,512);
         END;
         *)
     END;
     (* WrF1("%12u\n", count); *)
END Decode;

(*..............................................*)

PROCEDURE DecodeRaw(textsize:LONGCARD);

VAR c:INTEGER;
    count:LONGCARD;

BEGIN
     count := 0;
     WHILE count<textsize DO
         IF getc(c)<0 THEN RETURN END;
         putcupd(c);
         INC(count);
     END;
END DecodeRaw;

(****************************** MAIN BODY ********************************)

CONST nomatches = "No matching files.\n";
      DOSMAX = 1000;

TYPE LZHHdr = RECORD
                    HLen:SHORTCARD; (* Offset of CRC word, 0 to end *)
                    Checksum:SHORTCARD;  (* checksum of header bytes 2..35 *)
                    PackType:ARRAY[0..4] OF CHAR;
                    PackedSize:LONGCARD;
                    FileSize:LONGCARD;
                    TimeStamp:CARDINAL;
                    DateStamp:CARDINAL;
                    FileAttr:SHORTCARD;
                    Filler5:SHORTCARD;
                    FileNameLength:SHORTCARD;
                    Filename:ARRAY[0..81] OF CHAR; (* variable length *)
                    CRC:CARDINAL;
              END;

     DosInfo = RECORD
                     Attr:SHORTCARD;
                     TimeStamp:CARDINAL;
                     DateStamp:CARDINAL;
                     FileSize:LONGCARD;
                     Filename:ARRAY[0..12] OF CHAR;
               END;
     DosInfoPtr = POINTER TO DosInfo;
     Actions = (Abort,Add,Delete,Move,View,eXtract);

VAR Action:Actions;
    ArchiveExists:BOOLEAN;
    ArchiveName,TempArchive,Wildcard:ARRAY[0..81] OF CHAR;
    ArchiveTail:ARRAY[0..13] OF CHAR;
    DosDir:POINTER TO ARRAY[0..DOSMAX-1] OF DosInfo;
    DosDirPtr:POINTER TO ARRAY[0..DOSMAX-1] OF DosInfoPtr;

(*...........................................*)

PROCEDURE CalcCheckSum(VAR x:ARRAY OF BYTE; Lnth:CARDINAL; VAR Chk:CARDINAL);

VAR i:CARDINAL;
    p:POINTER TO ARRAY[0..255] OF CHAR;

BEGIN
     p:=ADR(x); i:=0;
     WHILE i<Lnth DO
         Chk := Chk + ORD(p^[i]);
         INC(i);
     END;
     Chk := CARDINAL(BITSET(Chk) * BITSET(0FFH));
END CalcCheckSum;

(*...........................................*)

(* read header and return header size, or 0 if failed. *)
PROCEDURE ReadHeader(infile:FIO.File; VAR hdr:LZHHdr):CARDINAL;

VAR lnth,Check:CARDINAL;
    p:POINTER TO ARRAY[0..255] OF CHAR;
    error:BOOLEAN;

BEGIN
     error := FALSE;
     IF (FIO.RdBin(infile,hdr,22)<>22) THEN
         error:=TRUE
       ELSE
         Check := 0;
         CalcCheckSum(hdr.PackType,20,Check);
         lnth := CARDINAL(hdr.FileNameLength);
         IF FIO.RdBin(infile,hdr.Filename,lnth)<>lnth THEN
             error:=TRUE
           ELSE
             CalcCheckSum(hdr.Filename,lnth,Check);
             hdr.Filename[lnth] := 0C;
             IF FIO.RdBin(infile,hdr.CRC,2)<>2 THEN
                 error:=TRUE
               ELSE
                 CalcCheckSum(hdr.CRC,2,Check);
                 IF Check<>CARDINAL(hdr.Checksum) THEN
                     WrF("Header is corrupt\n");
                     error := TRUE;
                 END;
             END;
         END;
     END;
     IF error THEN RETURN(0) ELSE RETURN(lnth+24) END;
END ReadHeader;

(*...........................................*)

PROCEDURE WriteHeader(outfile:FIO.File; VAR hdr:LZHHdr):CARDINAL;

VAR Check:CARDINAL;

BEGIN
     hdr.FileNameLength := SHORTCARD(Str.Length(hdr.Filename));
     hdr.HLen := 22+hdr.FileNameLength;
     Check := 0;
     CalcCheckSum(hdr.PackType,20,Check);
     CalcCheckSum(hdr.Filename,CARDINAL(hdr.FileNameLength),Check);
     CalcCheckSum(hdr.CRC,2,Check);
     hdr.Checksum := SHORTCARD(Check);
     FIO.WrBin(outfile,hdr,CARDINAL(hdr.HLen));
     FIO.WrBin(outfile,hdr.CRC,2);
     RETURN CARDINAL(hdr.FileNameLength)+24;
END WriteHeader;

(*...........................................*)

(* case insensitive pattern match *)
PROCEDURE Match(VAR strng,Pat:ARRAY OF CHAR):BOOLEAN;

VAR s,p:CHAR;
    si,pi:CARDINAL;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE nexts():BOOLEAN;
BEGIN
     IF (si=HIGH(strng)) THEN RETURN(FALSE) END;
     s := CAP(strng[si]); INC(si);
     RETURN s<>0C;
END nexts;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE nextp():BOOLEAN;
BEGIN
     IF (pi=HIGH(Pat)) THEN RETURN(FALSE) END;
     p := CAP(Pat[pi]); INC(pi);
     RETURN p<>0C;
END nextp;

(*. . . . . . . . . . . . . . . . . . . . . .*)

BEGIN
     si:=0; pi:=0;
     LOOP
         IF NOT nextp() THEN RETURN(NOT nexts()) END;
         IF p='*' THEN
             IF NOT nextp() THEN RETURN(TRUE) END;
             LOOP
                 IF NOT nexts() THEN RETURN(FALSE) END;
                 IF s=p THEN EXIT END;
             END;
             DEC(si);
             DEC(pi);
           ELSE
             IF NOT nexts() THEN RETURN(FALSE) END;
             IF (p<>'?') AND (s<>p) THEN RETURN(FALSE) END;
         END;
     END;
END Match;

(*...........................................*)

PROCEDURE GetFileList():CARDINAL;

VAR Count:CARDINAL;
    GotFile:BOOLEAN;
(*    name:ARRAY[0..12] OF CHAR; *)
    D: FIO.DirEntry;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE QuickSort(l,r:INTEGER);

VAR i,j,Cmp:INTEGER;
    x,w:DosInfoPtr;

BEGIN
     LOOP
         i:=l; j:=r;
         x := DosDirPtr^[(l+r) DIV 2];
         REPEAT
               WHILE Str.Compare(DosDirPtr^[i-1]^.Filename,
                                        x^.Filename) < 0 DO INC(i) END;
               WHILE Str.Compare(x^.Filename,
                                        DosDirPtr^[j-1]^.Filename) < 0 DO DEC(j) END;
               IF i<j THEN
                   w:=DosDirPtr^[i-1]; DosDirPtr^[i-1]:=DosDirPtr^[j-1];
                   DosDirPtr^[j-1]:=w;
                   INC(i); DEC(j);
                 ELSIF i=j THEN
                   INC(i); DEC(j);
               END;
         UNTIL i>j;

         (* try to minimise recursion - do recursive sort on largest
            partition, while remaining in loop for other partition *)
         IF j-l < r-i THEN
             IF i<r THEN QuickSort(i,r) END;
             IF l<j THEN r:=j ELSE EXIT END;
           ELSE
             IF l<j THEN QuickSort(l,j) END;
             IF i<r THEN l:=i ELSE EXIT END;
         END;
     END;
END QuickSort;

(*. . . . . . . . . . . . . . . . . . . . . .*)

BEGIN
     (* get list of files *)
     WrF1("Finding files matching: %s\n",Wildcard);

     Count := 0;
     Storage.ALLOCATE(DosDir,SIZE(DosInfo)*DOSMAX);
     Storage.ALLOCATE(DosDirPtr,4*DOSMAX);
     GotFile := FIO.ReadFirstEntry(Wildcard,FIO.FileAttr{},D);
     WHILE GotFile DO
         IF Str.Compare(ArchiveTail,D.Name)<>0 THEN
             Lib.Move(ADR(D.attr),ADR(DosDir^[Count]),SIZE(DosInfo));
             DosDirPtr^[Count] := ADR(DosDir^[Count]);
             INC(Count);
         END;
         GotFile := FIO.ReadNextEntry(D);
     END;

     (* sort list *)
     IF Count>1 THEN QuickSort(1,Count) END;
     RETURN Count;
END GetFileList;

(*...........................................*)

PROCEDURE FileCopy(src,dest:FIO.File; Lenth:LONGCARD);

VAR Bytes:CARDINAL;

BEGIN
     WHILE Lenth>0 DO
         IF Lenth>BUFFSIZE THEN Bytes:=BUFFSIZE ELSE Bytes:=CARDINAL(Lenth) END;
         Bytes := FIO.RdBin(src,input,Bytes);
         FIO.WrBin(dest,input,Bytes);
         DEC(Lenth,LONGCARD(Bytes));
     END;
END FileCopy;

(*...........................................*)

PROCEDURE ForgetThisFile(VAR fname:ARRAY OF CHAR):BOOLEAN;

VAR Drive,Ext:ARRAY[0..3] OF CHAR;
    Name:ARRAY[0..13] OF CHAR;
    Path:ARRAY[0..71] OF CHAR;

BEGIN
     IF ParseFilename(fname,Drive,Path,Name,Ext) THEN
         IF Str.Compare(Ext,"LZW")=0 THEN
             RETURN TRUE
           ELSIF Str.Compare(Ext,"PAK")=0 THEN
             RETURN TRUE
           ELSIF Str.Compare(Ext,"ZIP")=0 THEN
             RETURN TRUE
           ELSIF Str.Compare(Ext,"ARC")=0 THEN
             RETURN TRUE
         END;
     END;
     RETURN FALSE;
END ForgetThisFile;

(*...........................................*)

PROCEDURE FileCRC(infile:FIO.File; Lenth:LONGCARD):CARDINAL;

VAR c:INTEGER;
    Count:LONGCARD;

BEGIN
     Count:=0; ArcCRC:=0;
     WHILE Count<Lenth DO
         IF getcupd(c)<0 THEN RETURN(ArcCRC) END;
         INC(Count);
     END;
     RETURN ArcCRC;
END FileCRC;

(*...........................................*)

PROCEDURE AddFiles(Moving:BOOLEAN);

CONST TempFile = "DJARC.$$$";

VAR i,Count,hdrsize,ratio:CARDINAL;
    Cmp:INTEGER;
    Hdr:LZHHdr;
    OldArchive,NewArchive:FIO.File;
    OldOffset:LONGCARD;
    Drive,Ext:ARRAY[0..3] OF CHAR;
    Path,Fullname:ARRAY[0..81] OF CHAR;

BEGIN
     IF ParseFilename(Wildcard,Drive,Path,Fullname,Ext) THEN END;
     IF (Drive[0]<>0C) AND (Drive[1]<>':') THEN Str.Concat(Drive,':',Drive) END;
     i:=Str.Length(Path);
     IF (i>0) AND (Path[i-1]<>'\') THEN Str.Concat(Path,'\',Path) END;
     Str.Concat(Drive,Path,Path);

     i:=0; Count:=GetFileList(); OldOffset:=0;
     IF ArchiveExists THEN
         OldArchive:=FIO.Open(ArchiveName);
       ELSE
         OldArchive := FIONULLFILE;
     END;
     NewArchive:=FIO.Create(TempArchive);
     WHILE i<Count DO
         Str.Concat(Path,DosDirPtr^[i]^.Filename,Fullname);
         IF ArchiveExists THEN
             LOOP (* copy any files from old archive which precede the new file *)
                 hdrsize := ReadHeader(OldArchive,Hdr);
                 IF hdrsize=0 THEN
                     ArchiveExists:=FALSE; EXIT;
                   ELSE
                     Cmp := Str.Compare(Hdr.Filename,DosDirPtr^[i]^.Filename);
                     IF Cmp=0 THEN (* Identical filename - skip this entry *)
                         INC(OldOffset,Hdr.PackedSize+LONGCARD(hdrsize));
                         FIO.Seek(OldArchive,OldOffset);
                         EXIT
                       ELSIF Cmp<0 THEN (* copy this file to new archive *)
                         FIO.Seek(OldArchive,OldOffset);
                         FileCopy(OldArchive,NewArchive,Hdr.PackedSize+LONGCARD(hdrsize));
                         INC(OldOffset,Hdr.PackedSize+LONGCARD(hdrsize));
                       ELSE (* push this header back *)
                         FIO.Seek(OldArchive,OldOffset);
                         EXIT;
                     END;
                 END;
             END;
         END;

         WrF1("        Compressing %s\r",DosDirPtr^[i]^.Filename);
         outfile:=FIO.Create(TempFile);
         infile:=FIO.Open(Fullname);

         BytesLeft:=FIO.Size(infile); codesize:=0;
         getbuf:=0; getlen:=0; putbuf:=0; putlen:=0;
         inp:=0; inbytes:=0; outp:=0; ArcCRC:=0;

         WITH Hdr DO
             PackType := '-lh1-';
             FileSize := BytesLeft;
             TimeStamp := DosDirPtr^[i]^.TimeStamp;
             DateStamp := DosDirPtr^[i]^.DateStamp;
             FileAttr := DosDirPtr^[i]^.Attr;
             Filler5 := 0;
             Str.Copy(DosDirPtr^[i]^.Filename,Hdr.Filename);
         END;
         hdrsize := WriteHeader(outfile,Hdr);

         IF ForgetThisFile(Hdr.Filename) THEN
             ArcCRC := FileCRC(infile,BytesLeft);
             codesize:=BytesLeft+1; BytesLeft:=0;
           ELSE
             IF BytesLeft>0 THEN Encode() END;
             IF outp>0 THEN FIO.WrBin(outfile,output,outp) END;
         END;

         IF codesize<Hdr.FileSize THEN
             (* compression works, ie it produces a smaller file *)
             WITH Hdr DO
                 PackedSize := codesize;
                 CRC := ArcCRC;
             END;
             FIO.Seek(outfile,0);
             hdrsize := WriteHeader(outfile,Hdr);
             FIO.Seek(outfile,0);
             FileCopy(outfile,NewArchive,LONGCARD(hdrsize)+codesize);
           ELSE
             (* compression actually enlarges the file! *)
             WITH Hdr DO
                 PackedSize := textsize;
                 PackType[3] := '0';
                 CRC := ArcCRC;
             END;
             hdrsize := WriteHeader(NewArchive,Hdr);
             FIO.Seek(infile,0);
             FileCopy(infile,NewArchive,Hdr.FileSize);
         END;
         IF textsize=0 THEN ratio:=100 ELSE ratio := CARDINAL((Hdr.PackedSize*100) DIV textsize) END;
         WrF1("(%3u%%)  \n",ratio);
         FIO.Close(infile);
         FIO.Close(outfile);
         IF Moving THEN FIO.Erase(Fullname) END;
         INC(i);
     END;
     IF OldArchive<>FIONULLFILE THEN
         FIO.Close(OldArchive);
         FIO.Erase(ArchiveName);
     END;
     FIO.Close(NewArchive);
     FIO.Rename(TempArchive,ArchiveName);
     FIO.Erase(TempFile);
END AddFiles;

(*...........................................*)

PROCEDURE DeleteFiles;

VAR Hdr:LZHHdr;
    hdrsize:CARDINAL;
    offset:LONGCARD;

BEGIN
     offset:=0;
     infile:=FIO.Open(ArchiveName);
     outfile:=FIO.Create(TempArchive);
     LOOP
         hdrsize := ReadHeader(infile,Hdr);
         IF hdrsize=0 THEN EXIT END;
         IF Match(Hdr.Filename,Wildcard) THEN
             WrF1("Deleting %s\n",Hdr.Filename);
           ELSE
             FIO.Seek(infile,offset);
             FileCopy(infile,outfile,Hdr.PackedSize+LONGCARD(hdrsize));
         END;
         INC(offset,Hdr.PackedSize+LONGCARD(hdrsize));
         FIO.Seek(infile,offset);
     END;
     FIO.Close(infile);
     FIO.Close(outfile);
     FIO.Erase(ArchiveName);
     FIO.Rename(TempArchive,ArchiveName);
END DeleteFiles;

(*...........................................*)

PROCEDURE ViewFiles;

CONST Months = "JanFebMarAprMayJunJulAugSepOctNovDec";

VAR Hdr:LZHHdr;
    ratio,day,year,hour,min,sec,hdrsize:CARDINAL;
    MonthStr:ARRAY[0..5] OF CHAR;
    offset,TotalSize,TotalPacked:LONGCARD;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE GetDate(Date:CARDINAL);

VAR month:CARDINAL;

BEGIN
     day := Date MOD 32;
     month := (Date MOD 512) DIV 32;
     year := (Date DIV 512)+80;
     MonthStr := "xxx";
     Lib.Move(ADR(Months[month*3-3]),ADR(MonthStr),3);
END GetDate;

(*. . . . . . . . . . . . . . . . . . . . . .*)

PROCEDURE GetTime(Time:CARDINAL);
BEGIN
     sec := (Time MOD 32)*2;
     min := (Time MOD 2048) DIV 32;
     hour := Time DIV 2048;
END GetTime;

(*. . . . . . . . . . . . . . . . . . . . . .*)

BEGIN
     infile:=FIO.Open(ArchiveName);
     offset:=0; TotalSize:=0; TotalPacked:=0;
     WrF("Filename       Type   Length    Size      Ratio    Date       Time    CRC\n");
     WrF("--------       ----   ------    ----      -----  ---------  --------  ---\n");
     LOOP
         hdrsize := ReadHeader(infile,Hdr);
         IF hdrsize=0 THEN EXIT END;
         WITH Hdr DO
             IF Match(Filename,Wildcard) THEN
                 INC(TotalSize,FileSize);
                 INC(TotalPacked,PackedSize);
                 ratio := CARDINAL((PackedSize*100) DIV FileSize);
                 GetDate(DateStamp);
                 GetTime(TimeStamp);
                 WrF5("%-12s   %s  %-8u  %-8u  %3u%%   ",
                         Filename,PackType,FileSize,PackedSize,ratio);
                 WrF3("%02u-%s-%02u  ",day,MonthStr,year);
                 WrF4("%02u:%02u:%02u  %04H\n",hour,min,sec,CRC);
             END;
         END;
         INC(offset,Hdr.PackedSize+LONGCARD(hdrsize));
         FIO.Seek(infile,offset);
     END;
     IF TotalSize=0 THEN
         WrF(nomatches);
       ELSE
         ratio := CARDINAL((TotalPacked*100) DIV TotalSize);
         WrF("                      ------    ----      -----\n");
         WrF3("                      %-8u  %-8u  %3u%%\n",TotalSize,TotalPacked,ratio);
     END;
     FIO.Close(infile);
END ViewFiles;

(*...........................................*)

PROCEDURE ExtractFiles;

VAR Hdr:LZHHdr;
    Unpacked,hdrsize:CARDINAL;
    offset:LONGCARD;

BEGIN
     Unpacked:=0; offset:=0;
     infile:=FIO.Open(ArchiveName);
     LOOP
         hdrsize := ReadHeader(infile,Hdr);
         IF hdrsize=0 THEN EXIT END;
         IF Match(Hdr.Filename,Wildcard) THEN
             WrF1("Extracting %s...",Hdr.Filename);
             outfile:=FIO.Create(Hdr.Filename);

             BytesLeft:=Hdr.PackedSize; codesize:=0;
             getbuf:=0; getlen:=0; putbuf:=0; putlen:=0;
             inp:=0; inbytes:=0; outp:=0; ArcCRC:=0;

             IF Hdr.PackType[3]='0' THEN
                 DecodeRaw(Hdr.FileSize);
               ELSIF Hdr.PackType[3]='1' THEN
                 Decode(Hdr.FileSize);
               ELSE
                 WrF1("Don't know how to unpack %s\n",Hdr.Filename);
             END;

             IF outp>0 THEN FIO.WrBin(outfile,output,outp) END;
             FIO.Close(outfile);
             IF ArcCRC<>Hdr.CRC THEN WrF("Fails CRC check!") END;
             WrF("\n");
             INC(Unpacked);
         END;
         INC(offset,Hdr.PackedSize+LONGCARD(hdrsize));
         FIO.Seek(infile,offset);
     END;
     FIO.Close(infile);
     IF Unpacked=0 THEN WrF(nomatches) END;
END ExtractFiles;

(*...........................................*)

PROCEDURE MakeCRCTable;

CONST POLY = 0A001H;

VAR CRCIndex,CRC,i:CARDINAL;

BEGIN
     FOR CRCIndex := 0 TO 255 DO
         CRC := CRCIndex;
         FOR i:=0 TO 7 DO
             IF ODD(CRC) THEN
                 CRC := CARDINAL(BITSET(CRC>>1) / BITSET(POLY))
               ELSE
                 CRC := CRC>>1
             END;
         END;
         CRCTable[CRCIndex] := BITSET(CRC);
     END;
END MakeCRCTable;

(*.............................................*)

PROCEDURE StartUp;
BEGIN
     Lib.DisableBreakCheck;
     FIO.IOcheck:=FALSE;

     MakeCRCTable;

     WrF("Micropack File Compressor.     version 1.0\n");
     WrF("**** Placed in the Public Domain\n");
     WrF("**** No rights reserved, use at your own risk.\n\n");
END StartUp;

(*...........................................*)

PROCEDURE ShowUsage;
BEGIN
     WrF("usage: djarc [admvx] archive-name wild-spec\n");
END ShowUsage;

(*...........................................*)

PROCEDURE Wild(VAR s:ARRAY OF CHAR):BOOLEAN;

VAR i:CARDINAL;

BEGIN
     FOR i:=0 TO HIGH(s) DO
         IF s[i]=0C THEN RETURN(FALSE) END;
         IF (s[i]='*') OR (s[i]='?') THEN
             RETURN TRUE;
         END;
     END;
     RETURN FALSE;
END Wild;

(*...........................................*)

PROCEDURE ParseCommandLine():Actions;

VAR f:FIO.File;
    Drive,Ext:ARRAY[0..5] OF CHAR;
    Path,Name:ARRAY[0..80] OF CHAR;
    act:Actions;

BEGIN
     IF (argc<2) OR (Str.Length(argv[1]^)>1) THEN
         ShowUsage; RETURN Abort
     END;
     CASE CAP(argv[1]^[0]) OF
            'A':act := Add;
       |    'D':act := Delete;
       |    'M':act := Move;
       |    'V':act := View;
       |    'X':act := eXtract;
      ELSE
        ShowUsage; RETURN Abort;
     END;
     Str.Copy(argv[2]^,ArchiveName);
     IF (NOT Wild(ArchiveName)) AND ParseFilename(ArchiveName,Drive,Path,Name,Ext) THEN
         MakeFilename(Drive,Path,Name,".LZH",ArchiveName);
         MakeFilename(Drive,Path,Name,".$$$",TempArchive);
         MakeFilename('','',Name,".LZH",ArchiveTail);
       ELSE
         WrF1("Bad archive name - %s\n",ArchiveName);
         RETURN Abort;
     END;
     f:=FIO.Open(ArchiveName);
     ArchiveExists := (FIO.IOresult()=0);
     FIO.Close(f);
     IF ((act=Delete) OR (act=View) OR (act=eXtract)) AND (NOT ArchiveExists) THEN
         WrF1("%s not found.\n",ArchiveName);
         RETURN Abort;
     END;
     IF argc=2 THEN
         Wildcard := "*.*"
       ELSE
         Str.Copy(argv[3]^,Wildcard)
     END;
     RETURN act;
END ParseCommandLine;

(*...........................................*)

BEGIN
     StartUp;
     Action := ParseCommandLine();
     IF Action<>Abort THEN
         CASE Action OF
                 Add:AddFiles(FALSE);
           |  Delete:DeleteFiles;
           |    Move:AddFiles(TRUE);
           |    View:ViewFiles;
           | eXtract:ExtractFiles;
         END;
     END;
END DJArc2.
