MODULE Dict2;
(* Dict2, demo for Crt (Xtdlib Package) (C) by Marco van de Voort 1996
   The entire program requires VGA.

   Dict is a abbreviation for Dictatuur(dutch for Dictatorship). It's a form
   of the game of Life.

   The reason that the particular version I tried to reproduce here was
   called Dictatorship, was that the original version of procedure DoStuff
   was different, and the screen it converted was not convergent, neither
   color took control, this was called Democracy. By a small change in the
   algoritm of DoStuff one  of the colors filled the screen at the end,
   like in a Dictatorship.

   There are 4 versions

   The difference between Dict and Dict2 is the handling of the borders of the
   screen, in Dict the border units do not have neighbours outside the screen,
   so these units do not have 8 neigbours but 5, or even 3 (in the corners).
   In Dict2 the border-units of the screen are fixed on the initial colors,
   which makes colorsurface 'stick' on the walls.

   Dict is also a demonstration of the virtual screen.

   Dict3 and Dict4 are graphical version of resp. Dict and Dict2, and therefore
   Dict3 and Dict4 have a higher resolution, but are much slower.
   I recommend to compile Dict3 and Dict4 with a coprocessor on.

   Watch out, the const WeirdMode is a modenumber that is adapter specific.
   It sets my Trident in 120x60 mode. Adapt to a value specific for your own
   adapter.
   *)

FROM CoreCrt IMPORT Red,White,Screen,Black,ScrDat,Color,ClrScr,ChangeMode;
FROM Crt     IMPORT Detect;
FROM Lib     IMPORT RANDOMIZE,RANDOM;
FROM IO      IMPORT RdKey,KeyPressed,WrLngCard,WrStr,WrLn;
FROM ELib    IMPORT GetKey;

CONST WeirdMode=266;                       (* <------------ Watch out *)

CONST WhiteCrit=2;
      RedCrit  =2;

PROCEDURE DoGeneration(Times:CARDINAL);

VAR A,B,C,D,
    CWhite,CRed : CARDINAL;

PROCEDURE Process(Value:CARDINAL);

BEGIN
 IF Value   =ORD(Red) THEN
  INC(CRed);
 ELSIF Value=ORD(White) THEN
  INC(CWhite);
  END;
END Process;

BEGIN
 FOR D:=0 TO Times-1 DO
   B:=RANDOM(CARDINAL(ScrDat.Width));
   A:=RANDOM(CARDINAL(ScrDat.Depth)+1);
   IF ((B>0) AND (B<CARDINAL(ScrDat.Width)-1)) AND ((A>0) AND (A<CARDINAL(ScrDat.Depth))) THEN
    CWhite:=0;
    CRed  :=0;
    Process(Screen^[(A-1)*CARDINAL(ScrDat.Width)+B-1] DIV 4096);
    Process(Screen^[(A-1)*CARDINAL(ScrDat.Width)+B] DIV 4096);
    Process(Screen^[(A-1)*CARDINAL(ScrDat.Width)+B+1] DIV 4096);
    Process(Screen^[(A)*CARDINAL(ScrDat.Width)+B-1] DIV 4096);

    Process(Screen^[(A)*CARDINAL(ScrDat.Width)+B+1] DIV 4096);
    Process(Screen^[(A+1)*CARDINAL(ScrDat.Width)+B-1] DIV 4096);
    Process(Screen^[(A+1)*CARDINAL(ScrDat.Width)+B] DIV 4096);
    Process(Screen^[(A+1)*CARDINAL(ScrDat.Width)+B+1] DIV 4096);
    IF (CWhite>WhiteCrit) AND (CRed>RedCrit) THEN
     C:=RANDOM(2);
     IF C=1 THEN
      Screen^[A*CARDINAL(ScrDat.Width)+B]:=32+ORD(Red  )*4096;
     ELSE
      Screen^[A*CARDINAL(ScrDat.Width)+B]:=32+ORD(White)*4096;
      END;
    ELSE
     IF CWhite>WhiteCrit THEN
      Screen^[A*CARDINAL(ScrDat.Width)+B]:=32+ORD(White)*4096;
      END;
     IF CRed  >RedCrit THEN
      Screen^[A*CARDINAL(ScrDat.Width)+B]:=32+ORD(Red)*4096;
      END;
     END;
    END;
   END;
END DoGeneration;

VAR A,X,Y : CARDINAL;
    C     : Color;
    Nr,Wh,Re,Bl    : LONGCARD;

BEGIN
 ChangeMode(WeirdMode);
 Detect;
 RANDOMIZE;
 FOR Y:=0 TO CARDINAL(ScrDat.Depth) DO
  FOR X:= 0 TO CARDINAL(ScrDat.Width)-1 DO
   A:=RANDOM(2);
   IF A=1 THEN
    C:=Red;
   ELSE
    C:=White;
    END;
   Screen^[X+CARDINAL(ScrDat.Width)*Y]:=32+ORD(C)*4096;
   END;
  END;
 Nr:=0;
 WHILE NOT KeyPressed() DO
  DoGeneration(1000);
  INC(Nr,1000);
  END;
 FOR Y:=0 TO CARDINAL(ScrDat.Depth) DO
  FOR X:= 0 TO CARDINAL(ScrDat.Width)-1 DO
   A:=Screen^[X+CARDINAL(ScrDat.Width)*Y] DIV 4096;
   IF A=ORD(Red) THEN
    INC(Re);
   ELSIF A=ORD(White) THEN
    INC(Wh);
   ELSIF A=ORD(Black) THEN
    INC(Bl);
    END;
   END;
  END;
 ChangeMode(3);
 Detect;
 ClrScr;
 WrStr("Nr of tests : ");
 WrLngCard(Nr,8);
 WrLn;
 WrStr("White parts : ");
 WrLngCard(Wh,8);
 WrLn;
 WrStr("Red   parts : ");
 WrLngCard(Re,8);
 WrLn;
 WrStr("Black parts : ");
 WrLngCard(Bl,8);
 WrLn;
 A:=GetKey();
END Dict2.
