MODULE EDemo;
(* Demo belonging to ELib(XtdLib package), (C) by Marco van de Voort 1996
   Some Crt features are VGA, so the entire program requires VGA.

   CD-Rom detection not enabled yet, since CD-Rom module isn't finished yet,
   and I want all CD-rom support in one module, this program should return a
   nonfatal error when it tries to mount the CD-ROM. With some drivers however
   it gives some errors when no CDROM is in the drive.
   Also, under Windows it can take a REAL long time (20-30 seconds) this is
   caused by the fact that Windows captures the critical errorhandler of
   a Dos-box.

   Should compile under all memory-models (small..mthread and ovl). I've no
   experience with the dynalink model.

Speed detection acts weird on Cyrix 686's probably because only one instruction
is used to test the speed. This can be corrected by the way if the correct value
is known, and the processor etection is changed to detect Cyrix 686's.
Works quite well on Intel Pentiums, tested a 90 which gave values between
90 and 93, same for an 486 AMD DX2-80, which gave (dependant of waitstates
between 79 and 83). The Lib.Delay procedure is quite important, see comments
in source.

I'm currently working on the Cyrix problem, and I suggest not to use the speed
detection. The speed detection can cause division by zero runtime errors.
*)

(*# call(o_a_copy => off) *)

FROM MLib      IMPORT CpuSpeed,EnvironmentFind;
FROM IO        IMPORT WrLngCard,WrCharRep,WrStrAdj;
FROM Crt       IMPORT ClrScr,GotoXY,WhereX,WhereY,ChangeMode,CrtOff,WrBCD;
FROM CoreMulti IMPORT CheckTasker,OS2;
FROM SYSTEM    IMPORT Eval;

IMPORT IO,ELib,Lib,Str,XMS;

TYPE AMPMT= ARRAY[0..1] OF ARRAY[0..1] OF CHAR;

CONST AMPM=AMPMT("AM","PM");

VAR Cpu : CARDINAL;
    Piped : BOOLEAN;

PROCEDURE P_GetKey();

VAR A : CARDINAL;

BEGIN
 IF NOT Piped THEN
  A:=ELib.GetKey();
  END;
END P_GetKey;

PROCEDURE OnOff(Flag:CARDINAL);
(* Yuck, another one *)

BEGIN
 IF Flag>0 THEN
  IO.WrStr("Ok");
 ELSE
  IO.WrStr("Disabled");
  END;
IO.WrLn;
END OnOff;

PROCEDURE DoDrive(A : SHORTCARD;Drv:CHAR);
(* Also not my most intelligent procedure *)

BEGIN
IO.WrStr("Drive ");             IO.WrChar(Drv);
IO.WrCharRep(" ",19);           IO.WrStr(": ");
 CASE (A AND 7) OF
 | 0 :  IO.WrStr("Not available");
 | 1 :  IO.WrStr(" 360 KB 5.25 Drive");
 | 2 :  IO.WrStr(" 1.2 MB 5.25 Drive");
 | 3 :  IO.WrStr(" 720 KB  3.5 Drive");
 | 4 :  IO.WrStr("1.44 MB  3.5 Drive");
 | 5 :  IO.WrStr("2.88 MB  3.5 drive");
 END;
IO.WrLn;
END DoDrive;

PROCEDURE WrText(S:ARRAY OF CHAR);
(* This is really LOW, but it works, and making it a procedure
is smaller, and eases the sources readability :-) *)

BEGIN
 IO.WrStrAdj(S,-26);
 IO.WrStr(": ");
END WrText;

PROCEDURE Inst(Tsr:CARDINAL);
(* Aha, this looks better *)

VAR A : CARDINAL;

BEGIN
 A:=ELib.Installed(Tsr);
 CASE A OF
  | 255 : IO.WrStr("Installed");
  | 0   : IO.WrStr("Not installed");
  | 1   : IO.WrStr("Not installed and not ok to install");
 ELSE
  IF A>255 THEN
   IO.WrStr("Error "); IO.WrCard(A AND 255,0);
   IO.WrStr(" Occurred while detecting");
   END;
  IF (A=128) AND (Tsr=ELib.XMSDrv) THEN
   IO.WrStr("Installed");
   END;
  END;
 IO.WrLn;
END Inst;

PROCEDURE DoHandleTable;
(* Show XMS handletable *)

VAR A,B : CARDINAL;
    Fl  : BOOLEAN;

BEGIN
  Fl:=TRUE;
  FOR A:=0 TO 39H DO
   B:=CARDINAL(XMS.GetAvailEMBHandles(A)); (* Also handle information *)
   IF (XMS.XMSError = BYTE(0)) THEN (* No error occured? Then handle valid*)
    IF Fl THEN      (* First valid handle? Write out tableheading *)
     Fl:=FALSE;
     IO.WrStr("Handles available      :");      IO.WrCard(B,5);
     IO.WrLn; IO.WrLn;
     IO.WrStr("Handle   Size    Lock-status "); IO.WrLn;
     END;
    IO.WrCard(A,6);
    IO.WrCard(XMS.GetEMBSize(A),7);
    IO.WrCharRep(" ",5);
    IF XMS.GetEMBLock(A)=0 THEN
     IO.WrStr("UnLocked");
    ELSE
     IO.WrStr("Locked");
     END;
    IO.WrLn;
    END;
   END;
  IO.WrLn;
END DoHandleTable;

PROCEDURE GenSysNfo_CMOS;
(* First Screen, mainly CMOS information *)

VAR Speed:  LONGCARD;
    CMOS :  ELib.CMOSRec;
    A,B  : CARDINAL;
    S    : ARRAY[0..100] OF CHAR;

BEGIN
 IO.WrStr("Determining the speed of the processor.");
 IO.WrLn;
 Lib.Delay(750); (* Makes CpuSpeed detection more reliable, less chance
          on speed measuring during a SmartDrive/HyperDisk staged write. *)
 ClrScr;
 WrText("Processor");
 Cpu:=ELib.CpuType();
 IF Cpu<5 THEN
  IO.WrStr("80"); IO.WrCard(Cpu,0);  IO.WrStr("86");
  END;
 IF Cpu=5 THEN IO.WrStr("Pentium"); END;
 IF Cpu=6 THEN IO.WrStr("PentiumPro"); END;

(* CpuSpeed temporarily disabled, a fast processor (Cyrix 166+) gives a
    division by zero error because it's too fast. I assume a BSF instruction
    is *real* fast on a Cyrix, since this is the core of the speed measurement

 Speed:=CpuSpeed();    (* measure CpuSpeed *)
 Speed:=Speed DIV 1000000; IO.WrLngCard(Speed,0); *)


 IO.WrLn;

 WrText("VideoCard");
 CASE ELib.CardDetect() OF
  | ELib.NONE                 :  IO.WrStr("None?");
  | ELib.MDA                  :  IO.WrStr("MDA/Hercules");
  | ELib.CGA                  :  IO.WrStr("CGA");
  | ELib.EGA_Mono             :  IO.WrStr("EGA Monochrome");
  | ELib.EGA_Color            :  IO.WrStr("EGA Color");
  | ELib.MCGA_Mono            :  IO.WrStr("MCGA Monochrome");
  | ELib.MCGA_Color           :  IO.WrStr("MCGA Color");
  | ELib.VGA_Mono             :  IO.WrStr("VGA Monochrome");
  | ELib.VGA_Color            :  IO.WrStr("VGA Color");
  END;
 IO.WrLn;
 A:=Lib.QueryDosVersion();
 WrText("Dosversion"); IO.WrCard(A >>8,0); IO.WrChar("."); IO.WrCard(A AND 255,0);
 A:=ELib.Test4Dos();
 IF A>0 THEN
  WrText(", 4Dos version");
  IO.WrCard(A >>8,0); IO.WrChar("."); IO.WrCard(A AND 255,0);
  END;
 IO.WrLn;
 WrText("Dos resides");
 A:=ELib.WhereDos(); (* See comments in helptext ELib *)
 CASE A OF
  |    0   :         IO.WrStr("Resident in RAM  (conventional memory)");
  |    1   :         IO.WrStr('Resident in ROM  (conventional memory)');
  |    2   :         IO.WrStr('Loaded   in HMA  (RAM)');
  |    3   :         IO.WrStr('Loaded   in HMA  (ROM)');
 ELSE
  IO.WrStr("Undefined, code:"); IO.WrCard(A,5);
  END;
 IO.WrLn;
 ELib.ELib.ELib.GetCMOS(CMOS);
 WrText("Base Memory installed");
 IO.WrCard(CMOS.BaseMem,-5);IO.WrStr(" KB");IO.WrLn;
 WrText("Extended Memory installed");
 IO.WrCard(CMOS.XTDMem,-5);IO.WrStr(" KB");IO.WrLn;
 WrText("DateTime");
 A:=CARDINAL( CMOS.RTCB AND 2);          B:=CARDINAL(CMOS.Hr);
 IF A=0 THEN
  B:=B MOD 12;
  END;
 WITH CMOS DO
 ELib.DaTiToStr(B,CARDINAL(Min),CARDINAL(Sec),CARDINAL(Day),CARDINAL(Month),
             CARDINAL(Year)+100*CARDINAL(Century),"%w %j %D%L, %y %h:%m:%s",S);
 IO.WrStr(S);
 END;
 IF A=0 THEN
  IO.WrStr(" ");
  IO.WrStr(AMPM[CARDINAL(CMOS.Hr DIV 12)]);
  END;
 IO.WrLn;
 WrText("Alarmtime");
 B:=CARDINAL(CMOS.AlHr);
 IF A=0 THEN
  B:=B MOD 12;
  END;
 WITH CMOS DO
 ELib.DaTiToStr(B,CARDINAL(AlMin),CARDINAL(AlSec),0,0,0,"%h:%m:%s",S);
 IO.WrStr(S);
 END;
 IF A=0 THEN
  IO.WrStr(" ");
  IO.WrStr(AMPM[CARDINAL(CMOS.Hr DIV 12)]);
  END;
 IO.WrLn;
 WrText("RTCA register"); IO.WrShtHex(CMOS.RTCA,2);IO.WrStr("h");IO.WrLn;
 WrText("RTCB register"); IO.WrShtHex(CMOS.RTCB,2);IO.WrStr("h");IO.WrLn;
 WrText("RTCC register"); IO.WrShtHex(CMOS.RTCC,2);IO.WrStr("h");
 WrText("  -> Daylightsaving");
 OnOff(CARDINAL(CMOS.RTCB) AND 1);
 WrText("RTCD register"); IO.WrShtHex(CMOS.RTCD,2);IO.WrStr("h");
 IO.PrefixChar:=" ";
 WrText("  -> Battery");
 IF (CMOS.RTCD AND 128) # 0 THEN
 IO.WrStr ("Ok");
 ELSE
 IO.WrStr ("Jammed");
  END;
IO.WrLn;
 DoDrive((CMOS.DiskType) >>4 ,"A");
 DoDrive((CMOS.DiskType AND 0FH) ,"B");
 WrText("Reserved 1");
 IO.WrShtHex(CMOS.Res1,2); IO.WrChar("h");IO.WrLn;
 A:=CARDINAL(CMOS.HDType ) >>4;
 IF A=15 THEN
  A:=CARDINAL(CMOS.HD_C);
  END;
 B:=CARDINAL(CMOS.HDType AND 0FH);
 IF B=15 THEN
  B:=CARDINAL(CMOS.HD_D);
  END;
 WrText("First  Harddisk (HD 0)"); IO.WrCard(A,-3);IO.WrLn;
 WrText("Second Harddisk (HD 1)"); IO.WrCard(B,-3);IO.WrLn;
IO.WrStr(" (Equipment byte)");IO.WrLn;
 A:=CARDINAL(CMOS.Equipment);
 WrText("  - No of floppies"); IO.WrCard((A ) >>6+1,-3);IO.WrLn;
 B:=(A AND 030H) >>4;
 WrText("  - Monitor type");
 CASE B OF
  |  0 :IO.WrStr('Not CGA or MDA');
  |  1 :IO.WrStr('40x25 CGA');
  |  2 :IO.WrStr('80x25 CGA');
  |  3 :IO.WrStr('MDA (Monochrome)');
  END;
 IO.WrLn;
 WrText("  - Display status"); OnOff(A AND 8);
 WrText("  - Keyboard status"); OnOff(A AND 4);
 WrText("  - Coprocessor status"); OnOff(A AND 2);
 WrText("  - Floppy status"); OnOff(A AND 1);
END GenSysNfo_CMOS;

PROCEDURE GenSys2;

VAR A : CARDINAL;

BEGIN
 ClrScr;
 WrText("LastDrive");             IO.WrChar(CHR(ELib.LastDrv()+66)); IO.WrLn;
 WrText("No. floppy drives");   IO.WrCard(ELib.NrFloppies(),-3);   IO.WrLn;
 WrText("No. harddisks");       IO.WrShtCard(ELib.FixedDisks,-3);  IO.WrLn;
 WrText("No. logical drives");  IO.WrCard(ELib.NrDrives(),-3);     IO.WrLn;
 WrText("FILES (No. filehandles)");                 IO.WrCard(ELib.ConfigFiles(),-3);  IO.WrLn;
 WrText("FILES Used");            IO.WrCard(ELib.FilesUsed(),-3);
 IO.WrStr("   ->  FILES Unused : ");
 IO.WrCard(ELib.ConfigFiles()-ELib.FilesUsed(),-3);  IO.WrLn;
 IO.WrStr(" (Installation checks)");
 IO.WrLn;
 WrText(" PRINT");                      Inst(ELib.Print);
 WrText(" PC LAN redirector");          Inst(ELib.PcLan);
 WrText(" Dos critical errorhandler");  Inst(ELib.DosCrit);
 WrText(" ASSIGN");                     Inst(ELib.Assign);
 WrText(" DRIVER.SYS");                 Inst(ELib.Driver);
 WrText(" SHARE.EXE");                  Inst(ELib.Share);
 WrText(" Network redirector");         Inst(ELib.Network);
 WrText(" NLSFUNC.COM");                Inst(ELib.NlsFunc);
 WrText(" Graphics.com or CDROM");      Inst(ELib.Graphics);
 WrText(" Windows");      A:=ELib.Installed(ELib.Windows);
 CASE A OF
  | 0 :  IO.WrStr("Not running under Windows");
  | 2 :  IO.WrStr("Running under Windows 2.x");
  ELSE
   IO.WrStr("Running under Windows ");
   IO.WrCard(A >> 8,0); IO.WrChar("."); IO.WrCard(A AND 255,0);

   END;
 IO.WrLn;
 WrText(" ShellB");                     Inst(ELib.ShellB);
 WrText(" ANSI.SYS");                   Inst(ELib.Ansi);
 WrText(" XMA2EMS");                    Inst(ELib.Xma2Ems);
 WrText(" XMS driver");                 Inst(ELib.XMSDrv);
 WrText(" ScrnSav2.com");               Inst(ELib.ScrnSav2);
 WrText(" Novell IPX drivers");         Inst(ELib.NovelIpx);
 WrText(" Append");                     Inst(ELib.Append);
END GenSys2;

PROCEDURE ScanEnvironment;

VAR Env : ELib.EnvRec;
    P,
    A,
    N : CARDINAL;
    pp  : Lib.CommandType;
    C   : CHAR;

BEGIN
 ClrScr;
 Env.EnvSeg:=4321;
 Env.EnvLen:=1234;
 IF CheckTasker()=OS2 THEN
  ELib.CurrentEnv(Env);
 ELSE
  ELib.MasterEnv(Env);
  END;
 WrText("The Master environment");
 IO.WrLn;
 IO.PrefixChar:="0";
 WrText(" Location");  IO.WrHex(Env.EnvSeg,5); IO.WrChar(":");
                       IO.WrHex(0,4);          IO.WrLn;
 IO.PrefixChar:=" ";
 WrText(" Size"); IO.WrCard(Env.EnvLen,10); IO.WrLn;
 WrText(" Bytes free in environment"); IO.WrCard(ELib.EnvFree(Env),10); IO.WrLn;
  N := 0;
  P:=3;
  LOOP
   pp := ELib.MEnvironment(N,Env);
   IF (P>21) AND (pp^[0] # CHR(0)) THEN
    P:=1;
    P_GetKey();
    ClrScr;
    END;
   IF (pp^[0] = CHR(0)) OR (pp=NIL) THEN
    EXIT
    END;
   A:=Str.CharPos(pp^,"=");
   pp^[A]:=CHR(0);
   IO.WrStrAdj(pp^,-15);
   IO.WrStr(" = ");
   pp^[A]:='=';
   pp:=FarADR(pp^[A+1]);
   LOOP
    IF Str.Length(pp^)<50 THEN
     IO.WrStr(pp^);
     EXIT
     END;
    C:=pp^[49];
    pp^[49]:=CHR(0);
    IO.WrStr(pp^);
    IO.WrLn;
    IO.WrCharRep(" ",18);
    pp^[49]:=C;
    pp:=FarADR(pp^[49]);
    INC(P);
    END;
   IO.WrLn;
   INC(N);
   INC(P);

  END;
END ScanEnvironment;

PROCEDURE DeviceDriversList;

VAR LoL    : ELib.ListOfListPtr;
    Dev    : ELib.DeviceDrvRecPtr;

BEGIN
 IO.WrStr("Devicedrivers detected : "); IO.WrLn;
 LoL   :=ELib.ListOfLists();
 IO.WrStr(LoL^.NulDrv.Name); IO.WrLn;
 Dev:=LoL^.NulDrv.Next;
 LOOP
  IF Ofs(Dev^.Next)=0FFFFH THEN
   EXIT
   END;
  IF (Dev^.Attr AND 8000H) > 0 THEN
   IO.WrStrAdj(Dev^.Name,-25);
  ELSE
   IO.WrStrAdj("Drive letters",-25);
   END;
   IO.WrLn;
  Dev:=Dev^.Next;
  END;
END DeviceDriversList;

PROCEDURE DisplUART(H:CARDINAL;Name:ARRAY OF CHAR;Num:CARDINAL);

BEGIN
 IO.WrHex(H,8); IO.WrStr("H "); IO.WrStr(Name); IO.WrCard(Num,0);
 IF H=0 THEN
  IO.WrStr(' not defined')
 ELSE
  CASE ELib.TestUART(H) OF
   |   ELib.uNoUART: IO.WrStr(' not present');
   |   ELib.uBadUART: IO.WrStr(' broken');
   |   ELib.u8250: IO.WrStr(' 8250B');
   |   ELib.u16450: IO.WrStr(' 16450');
   |   ELib.u16550: IO.WrStr(' 16550');
   |   ELib.u16550a: IO.WrStr(' 16550A');
  ELSE
      IO.WrStr(' unknown');
    END
   END;
  IO.WrLn;
END DisplUART;

PROCEDURE GenSys3;
(*# save *)
(*# data(near_ptr => off) *)

TYPE BytePtr=POINTER TO BYTE;
(*# restore *)
VAR Mod,Sub : BYTE;
    i       : CARDINAL;

BEGIN
 ClrScr;
 Mod:=[0F000H:0FFFEH BytePtr]^;
 Sub:=[0F000H:0FFFFH BytePtr]^;
 IO.WrStr("Model    : "); IO.WrShtHex(Mod,2); IO.WrStr("H"); IO.WrLn;
 IO.WrStr("SubModel : "); IO.WrShtHex(Sub,2); IO.WrStr("H");IO.WrLn;
 IO.WrStr("-> ");
 CASE Mod OF
       0FFH : IO.WrStr("IBM PC");
     | 0FEH : IO.WrStr("PC/XT (11/08/82 BIOS)");
     | 0FDH : IO.WrStr("PCjr");
     | 0FCH : CASE Sub OF
              | 0: IO.WrStr("PC/AT (6/10/85 BIOS)");
              | 1: IO.WrStr("PC/AT (11/15/85 BIOS)");
              | 2: IO.WrStr("PC/XT-286");
              | 4: IO.WrStr("PS/2 Model 50[Z]");
              | 5: IO.WrStr("PS/2 Model 60");
             ELSE
              IO.WrStr(" General PC-AT clone");
              END;
     | 0FBH : IO.WrStr("PC/XT (1/10/86 and 5/9/86 BIOS)");
     | 0FAH : IO.WrStr("PS/2 Model 30");
     | 0F9H : IO.WrStr("PC Convertible");
     | 0F8H : CASE Sub OF
              | 0: IO.WrStr("PS/2 Model 80 (16MHz)");
              | 1: IO.WrStr("PS/2 Model 80 (20MHz)");
              | 4: IO.WrStr("PS/2 Model 70 (20MHz)");
              | 9: IO.WrStr("PS/2 Model 70 (16MHz)");
              |0CH:IO.WrStr("PS/2 Model 55");
              |0DH:IO.WrStr("PS/2 Model 70 (25MHz)");
             ELSE
              IO.WrStr("Unknown, but probably a PS/2");
              END;
      ELSE
       IO.WrStr("Unknown or PC/AT clone or higher");
       END;
   IO.WrLn;
   IO.WrLn;
   IO.WrStr("Port information:"); IO.WrLn;
   IO.WrStr(" Testing standard COM-port addresses(usually most correct) : ");
   IO.WrLn;
   FOR i := 1 TO 4 DO
    DisplUART(02E8H+ 100H * (i AND 1) + 10H * ORD(i < 3),"COM",i);
    END;
   IO.WrLn;
   IO.WrStr(" Testing for PS/2 COM-port addresses : ");
   IO.WrLn;
   FOR i := 3 TO 8 DO
    DisplUART(3220H + 1000H * ((i - 3) DIV 2) + 8 * ORD(NOT ODD(i)),"PS/2 COM",i);
    END;
   IO.WrLn;
   IO.WrStr(" Testing for COM-port addresses as defined in BIOS : ");
   IO.WrLn;
    FOR i := 1 TO 4 DO
     DisplUART(ELib.BIOSPortTab[i], 'BIOS COM', i);
     END;
   P_GetKey();
   ClrScr;
   DeviceDriversList;
END GenSys3;

PROCEDURE YesNo(A,B:CARDINAL);

BEGIN
 IF B IN BITSET(A) THEN
  IO.WrStr("YES");
 ELSE
  IO.WrStr("NO");
  END;
 IO.WrLn;
END YesNo;

PROCEDURE DoCpuID;

TYPE IDStrType= ARRAY[0..11] OF CHAR;
     IdArr= ARRAY[0..2] OF LONGCARD;

VAR A,B    : CARDINAL;
    IDStr  : IdArr;

BEGIN
 ClrScr;
 IO.WrStr("CPUID information (Pentium or higher)"); IO.WrLn;
 WrText("Number of supported functions");
 IO.WrLngCard(ELib.CpuID(0,0),5); IO.WrLn; (*EAX=0 CPUID return EAX*)
 WrText("Identificationstring");
 IDStr[0]:=ELib.CpuID(0,1);              (*EAX=0 CPUID return EBX*)
 IDStr[1]:=ELib.CpuID(0,3);              (*EAX=0 CPUID return EDX*)
 IDStr[2]:=ELib.CpuID(0,2);              (*EAX=0 CPUID return ECX*)
 IO.WrStr(IDStrType(IDStr));     IO.WrLn;
 A:=CARDINAL(ELib.CpuID(1,0));  (* EAX=1, CPUID, return EAX*)
 WrText("Model number"); IO.WrCard((A AND 255)>>4,5); IO.WrLn;
 WrText("Revision"); IO.WrCard(A AND 15,5); IO.WrLn;
 WrText("Type");      IO.WrCard(A >>11,5); IO.WrLn;
 A:=CARDINAL(ELib.CpuID(1,3));   (*EAX=1 CPUID return EDX *)
 IO.WrStr("Featurebits"); IO.WrLn;
 IO.WrStrAdj("  CPU contains a local APIC (iPentium-3V)",-45); YesNo(A,9);
 IO.WrStrAdj("  CMPXCHG8 instruction",-45); YesNo(A,8);
 IO.WrStrAdj("  Machinecheck exception",-45); YesNo(A,7);
 IO.WrStrAdj("  reserved (36bit-addressing & 2MB-paging)",-45); YesNo(A,6);
 IO.WrStrAdj("  iPentium-style MSRs supported ",-45); YesNo(A,5);
 IO.WrStrAdj("  time stamp counter TSC supported",-45); YesNo(A,4);
 IO.WrStrAdj("  page size extensions supported",-45); YesNo(A,3);
 IO.WrStrAdj("  I/O breakpoints supported",-45); YesNo(A,2);
 IO.WrStrAdj("  CPU contains a floating-point unit (FPU)",-45); YesNo(A,1);
 IO.WrStrAdj("  Copro internal",-45); YesNo(A,0);
END DoCpuID;


PROCEDURE DoCountry;

VAR R : ELib.CountryType;
    O : BOOLEAN;
    A : CARDINAL;

PROCEDURE WriteDigits;

VAR B : CARDINAL;

BEGIN
 FOR B:= 1 TO CARDINAL(R.SignificantDec) DO
  IO.WrCard(B,0);
  END;
END WriteDigits;

BEGIN
 ClrScr;
 Eval(ELib.GetCountryInfo(R,0));
 IO.WrStr("Country specific crap"); IO.WrLn;
 WrText("Country code"); IO.WrCard(R.Code,0); IO.WrLn;
 WrText("DateFormat");
 CASE R.DateFormat OF
  | 0 : IO.WrStr("USA    : mm-dd-yy")
  | 1 : IO.WrStr("Europe : dd-mm-yy")
  | 2 : IO.WrStr("Japan  : yy-mm-dd")
 ELSE
  IO.WrStr("Unknown dateformat");
  END;
 IO.WrLn;
 WrText("Currency symbol"); IO.WrChar(R.Currency[1]); IO.WrLn;
 WrText("Thousands separator char"); IO.WrChar(R.ThouSep[1]); IO.WrLn;
 WrText("Decimal separator char"); IO.WrChar(R.DecSep[1]); IO.WrLn;
 WrText("Date separator char"); IO.WrChar(R.DateSep[1]); IO.WrLn;
 WrText("Time separator char"); IO.WrChar(R.TimeSep[1]); IO.WrLn;
 WrText("Currencyformat");
 IF (CARDINAL(R.CurrencyFormat) AND 4) = 0 THEN
  O:=ODD(R.CurrencyFormat);
  A:=(CARDINAL(R.CurrencyFormat) AND 2);
  IF NOT O THEN
   IO.WrStr(R.Currency[1]);
   IF A # 0 THEN
    IO.WrCharRep(" ",A);
    END;
   END;
  IO.WrStr("123."); WriteDigits;
  IF O THEN
   IO.WrStr(R.Currency[1]);
   IF A # 0 THEN
    IO.WrCharRep(" ",A);
    END;
   END;
 ELSE
  IO.WrStr(" 123 "); IO.WrStr(R.Currency); WriteDigits; IO.WrLn;
  END;
 IO.WrLn;
 WrText("Timeformat");
 CASE ODD(R.TimeFormat) OF
  | TRUE  : IO.WrStr("24 hour clock");
  | FALSE : IO.WrStr("12 hour clock");
  END;
  IO.WrLn;
  WrText("CaseMapAddress");
  IO.PrefixChar:='0';
  IO.WrHex(CARDINAL(LONGCARD(R.CaseMapAddress)>>16),4); IO.WrChar(":");
  IO.WrHex(CARDINAL(R.CaseMapAddress),4); IO.WrLn;
  IO.PrefixChar:=' ';
  WrText("Data separator");          IO.WrStr(R.DataListSep); IO.WrLn;
  IO.WrLn;
END DoCountry;

PROCEDURE DoDrives;

VAR A           : BYTE;
    B,C         : CARDINAL;
    Dat         : ELib.DrvRec;
    Device      : ELib.DeviceRec;
    Substed     : BOOLEAN;
    S           : ARRAY[0..128] OF CHAR;

BEGIN
 FOR B:=1 TO ELib.NrDrives() DO
  ClrScr;
  Substed:=FALSE;
  IO.WrStr(" Data for Drive ");
  IO.WrChar(CHR(B+64));IO.WrChar(":");IO.WrLn; IO.WrLn;
  WrText("Status");
  IF ((B=2) AND (ELib.NrFloppies()=1)) THEN
  IO.WrStr("Drive not available");
  ELSE
   A:=BYTE(ELib.DiskChange(SHORTCARD(B)));
   IF (A = BYTE(6)) THEN
   IO.WrStr ("Changing disks");
   ELSE
    C:=ELib.DriveType(SHORTCARD(B));
    CASE C OF
     | 0     :IO.WrStr ("Drive physically isn't available");
     | 1     :IO.WrStr ("Remote (network) disk drive");
     | 2     :IO.WrStr ("Fixed (hard) disk drive");
     | 3     :IO.WrStr ("Removable (floppy) disk drive");
     | 4     :IO.WrStrAdj ("Substed drive",-20);
              IO.WrLn;
              IO.WrStr("Substed path : ");
              Substed:=TRUE;
     END;
    IF C= 4 THEN
     S:="C:\";
     S[0]:=CHR(B+64);
     IF NOT ELib.ExpPath(S) THEN
      IO.WrStr(S);
      END;
    ELSIF C # 0 THEN
    IO.WrLn;
    WrText("Bytes free on volume");
    IO.WrLngCard(ELib.FreeBytes(SHORTCARD(B)),15); IO.WrLn;
    WrText("Disksize in bytes");
    IO.WrLngCard(ELib.DiskSize(SHORTCARD(B)),15); IO.WrLn;
     END;
    END;
   IO.WrLn;
   END;
   C:=ELib.GetDrvInfo(SHORTCARD(B),Dat);
   IF (C = 0) AND NOT Substed THEN
    IO.PrefixChar:="0";
    WrText("SerialNumber"); IO.WrHex(CARDINAL(LONGCARD(Dat.Serial)>>16),4);
    IO.WrChar(":");         IO.WrHex(CARDINAL(Dat.Serial),4);  IO.WrLn;
    IO.PrefixChar:=" ";
    WrText("VolumeLabel");  IO.WrStr(Dat.Volume);IO.WrLn;
    WrText("FAT-type");  IO.WrStr(Dat.FileSys);IO.WrLn;
   ELSIF (C=5) AND (A # BYTE(6)) THEN
    ELib.GetVolume(S,SHORTCARD(B));
    WrText("VolumeLabel");  IO.WrStr(S);IO.WrLn;
    END;

    Device.Spec:=4;
    A:=BYTE(ELib.DeviceData(SHORTCARD(B),Device));
    IF (A=BYTE(0)) AND NOT Substed THEN

     WrText("DriveType");
     CASE Device.Device OF
      | 0 :  IO.WrStr("320K/360K disk");
      | 1 :  IO.WrStr("1.2M disk");
      | 2 :  IO.WrStr("720K disk");
      | 3 :  IO.WrStr("single-density 8-inch disk");
      | 4 :  IO.WrStr("double-density 8-inch disk");
      | 5 :  IO.WrStr("fixed disk");
      | 6 :  IO.WrStr("tape drive");
      | 7 :  IO.WrStr("1.44M disk");
      | 8 :  IO.WrStr("read/write optical disk");
      | 9 :  IO.WrStr("2.88 MBytes floppy");
      ELSE
       IO.WrStr("Unknown device type");
       END;
     IO.WrLn;
     WrText ("Media ID");          A:=Device.MediaID;
     IO.WrHex(CARDINAL(A),2); IO.WrStr("h (= ");
     CASE A OF
      | 0FFH  :  IO.WrStr("320k floppy");
      | 0FEH  :  IO.WrStr("160k floppy");
      | 0FDH  :  IO.WrStr("360k floppy");
      | 0FCH  :  IO.WrStr("180k floppy");
      | 0FAH  :  IO.WrStr("HP 200LX ROM disk (995K)");
      | 0F9H  :  IO.WrStr("1.2M or 720k floppy");
      | 0F8H  :  IO.WrStr("harddisk");
      | 0F0H  :  IO.WrStr("1.44M floppy or unknown mediatype");
      END;
     IO.WrStr(")");
     IO.WrLn;
     WrText("Attributes");
     IF (CARDINAL(Device.Attr) AND 1)=1 THEN
      IO.WrStr("non-");
      END;
     IO.WrStr("removable");
     IF (CARDINAL(Device.Attr) AND 2)=2 THEN
      IO.WrStr(", Doorlock supported");
      END;
     IO.WrLn;
     WrText ("Cylinders");          IO.WrCard(Device.NrCylinders,10);  IO.WrLn;
     WrText ("Sectorsize");         IO.WrCard(Device.Byte_Sector,10);    IO.WrLn;
     WrText ("Number of heads");    IO.WrCard(Device.NrHeads,10);        IO.WrLn;
     WrText ("Sectors per track");  IO.WrCard(Device.Sec_Track,10);      IO.WrLn;
     WrText ("Sectors per cluster");  C:=CARDINAL(Device.Sec_Cluster);
                                    IO.WrCard(C,10);
     WrText ("  Clustersize"); IO.WrCard(C*Device.Byte_Sector,10); IO.WrLn;
     WrText ("Sectors reserved");   IO.WrCard(Device.Res_Sector,10);    IO.WrLn;
     WrText ("Number of FATs");     IO.WrCard(CARDINAL(Device.Fats),10);
     WrText ("  Sectors per FAT");    IO.WrCard(Device.Sec_Fat,10);       IO.WrLn;
     WrText ("Entries in rootdirectory");
                                    IO.WrCard(Device.RootEntries,10);
     WrText ("  Hidden sectors");    IO.WrLngCard(Device.HiddenSec,10); IO.WrLn;
     WrText ("Total number of sectors");   C:=Device.NrSectors;
     IF C=0 THEN
      IO.WrLngCard(Device.Totalsectors,10);
     ELSE
      IO.WrCard(C,10);
      END;
     IO.WrLn;
    ELSE
     IF NOT Substed AND (A # BYTE(15)) THEN
      WrText("Request errorcode");     IO.WrCard(CARDINAL(A),5);     IO.WrLn;
      IO.WrStr(" CdRom?");  IO.WrLn;
      END;
     END;
   P_GetKey();
   END;
END DoDrives;

PROCEDURE DoXMSDriver;

VAR Handle : CARDINAL;
    Adr    : LONGCARD;
    A,X,Y  : CARDINAL;

BEGIN
 ClrScr;
 IF XMS.Present THEN
  IO.WrStr("The XMS-driver reports  :"); IO.WrLn;
  IO.WrStr("XMS Version            :"); WrBCD(XMS.GetXMSVersion(),2,2);    IO.WrLn;
  IO.WrStr("XMM Version            :"); WrBCD(XMS.GetXMMVersion(),2,2);    IO.WrLn;
  IO.WrStr("Total available XMS    :");IO.WrCard(XMS.XMSMemAvail(),6); IO.WrLn;
  IO.WrStr("Largest available block:");IO.WrCard(XMS.XMSMaxAvail(),6); IO.WrLn;
  IO.WrStr("The A20 line is ");
  IF XMS.GetA20Status() THEN
   IO.WrStr("enabled.");
  ELSE
   IO.WrStr("disabled.");
   END;
  IO.WrLn;
  IO.WrStr("The HMA ");
  IF XMS.GetHMA() THEN
    IO.WrStr("exists and is ");
    XMS.HMAGetMem(10);
    IF XMS.XMSError # BYTE(0) THEN
     IO.WrStr("not ");
     END;
    IO.WrStr("free.");
  ELSE
   IO.WrStr("does not exist.");
   END;
 IO.WrLn;
 DoHandleTable;
 IO.WrStrAdj("Allocating 10KB",-35);
 Handle:=XMS.EMBGetMem(10);
 IF XMS.XMSError#BYTE(0) THEN
  IO.WrStr(": Allocation failed");
 ELSE
  IO.WrStr(": OK, handle : ");
  IO.WrCard(Handle,5);
  IO.WrLn;
  IO.WrStrAdj("Resizing handle to 9kb",-35);
  XMS.EMBResize(Handle,9);
  IF XMS.XMSError=BYTE(0) THEN
   IO.WrStr(": OK");
  ELSE
   IO.WrStr(": Resizing failed, errorcode :");
   IO.WrShtCard(XMS.XMSError,5);
   IO.WrLn;
   END;
  IO.WrLn;

  Adr:=XMS.LockEMB(Handle);
  IO.WrStr("Under Windows, locking is rejected, but it won't mess up your computer!");
  IO.WrLn;
  IO.WrStrAdj("Trying to lock block",-35);
  IF XMS.XMSError=BYTE(0) THEN
   IO.WrStr(": successful, locked at ");
   IO.PrefixChar:="0";
   IO.WrLngHex(Adr>>16,4);
   IO.WrChar(":");
   IO.WrHex(CARDINAL(Adr),4);
   IO.WrChar("h");
   IO.PrefixChar:=" ";
  ELSE
   IO.WrStr(": Locking failed !!!!!!!!");
   END;
  IO.WrLn;
  IO.WrStrAdj("Saving 4Kb screendata to XMS",-35);
  XMS.MoveToEMB([0B800H:0],Handle,4096,0);
  IF XMS.XMSError=BYTE(0) THEN
   X:=WhereX(); Y:=WhereY();
   IO.WrStr(": successful, press a key");
   P_GetKey();
   ChangeMode(3);
   GotoXY(0,0);
   IF Piped THEN
    IO.WrLn;
    END;
   IO.WrStr("Screen cleared, trying to recover screen, press a key");
   P_GetKey();
   XMS.MoveFromEMB([0B800H:0],Handle,4096,0);
   GotoXY(X,Y);
   IO.WrStr(": successful");  IO.WrLn;
   IO.WrStrAdj("Recovery of screen from XMS",-35);
   IF XMS.XMSError=BYTE(0) THEN
    IO.WrStr(": succesfull");
   ELSE
    IO.WrStr(": Returned error :");
    IO.WrCard(CARDINAL(XMS.XMSError),5);
    END;
   IO.WrLn;
  ELSE
   IO.WrStr(": movement failed !");
   END;
  IO.WrStrAdj("Trying to unlock block",-35);
  XMS.UnlockEMB(Handle);
  IF XMS.XMSError#BYTE(0) THEN
   IO.WrLn;
   IO.WrStr(": unlocking failed, handle may remain occupied!");
  ELSE
   IO.WrStr(": unlocking succesfull");
   END;
  IO.WrLn;
  IO.WrStrAdj("Trying to deallocate block",-35);
  XMS.EMBFreeMem(Handle);
  IF XMS.XMSError#BYTE(0) THEN
   IO.WrStr(": deallocation failed");
  ELSE
   IO.WrStr(": deallocation successfull");
   END;
  END;
 IO.WrLn;
 IO.WrStrAdj("Trying to get all HMA space",-35);
 XMS.HMAGetMem(0FFFFH);
 IF XMS.XMSError=BYTE(091H) THEN
  IO.WrStr(": HMA already in use");
 ELSIF XMS.XMSError=BYTE(0) THEN
  IO.WrStr(": Success");
 ELSE
  IO.WrStr(": Error :"); IO.WrShtCard(XMS.XMSError,5);
  END;
 IO.WrLn;
 IO.WrStrAdj("Trying to allocate 16k UMB",-35);
 A:=XMS.UMBGetMem(1024,X);
 IF XMS.XMSError=BYTE(0B1H) THEN
  IO.WrStr(": no UMB's available");
 ELSIF XMS.XMSError=BYTE(0) THEN
  IO.WrStr(": Succesfull, segment= "); IO.WrHex(X,4); IO.WrChar("h");
  IO.WrStr(" Size="); IO.WrCard(A,5);
 ELSE
  IO.WrStr(": Error :"); IO.WrShtCard(XMS.XMSError,5);
  END;
 IO.WrLn;
ELSE
 IO.WrStr("No XMS present, I'm sorry");
 END;
END DoXMSDriver;

VAR A :BYTE;

BEGIN
 CrtOff;
 (* Dirty pipe detection, if Piped, I can't read back a character from screen.
 *)
 GotoXY(0,0);
 IO.WrStr("A");
 Piped:=FALSE;
 IF CHAR([0B800H:0]^) # "A" THEN
  Piped:=TRUE;
  END;
 GenSysNfo_CMOS; (*  Display general info, mainly the CMOS and cpuspeed*)
 P_GetKey();
 GenSys2;        (*  More general information, mainly multiplex *)
 P_GetKey();
 GenSys3;        (*  (IBM) Model information and Comports *)
 P_GetKey();
 ScanEnvironment;               (* Master environment *)
 P_GetKey();
 DoCountry;                     (* Country information *)
 P_GetKey();
 IF Cpu>4 THEN
   DoCpuID;
   P_GetKey();
   END;
 DoDrives;                      (* Drive information *)
 DoXMSDriver;                   (* XMSdriver test *)
END EDemo.