MODULE FontEditor;
(* Simple Fonteditor demo, XtdLib package, (C) by Marco van de Voort 1996
   VGA(EGA?) only!!

   Demonstration of the FontLib package.
   Both this demo and FontLib are initial versions. It will probably have
   several bugs, but I guess the worst it will do is lock up your computer
   *)


FROM IO      IMPORT WrStr, KeyPressed,RdChar,RdKey,RdCard,WrCard,WrLn,RdStr,
                    WrCharRep;
FROM Lib     IMPORT Fill;
FROM CoreFntL IMPORT SizeChar,SizeCharsetP,BByte,Wid;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,HeapTotalAvail,MainHeap;
FROM FontLib IMPORT             Char      ,GDisplChar,
                    GetChar  ,GDisplRow ,StoreChar, MirrorChar  , MirrorX,
                    SymX     ,SymCharY  ,ShiftU     ,ShiftD     ,FontR,
                    ShiftL   ,ShiftR    ,LongBitSet ,ShiftLRow  ,ShiftRRow,
                    ShiftUCol,ShiftDCol ,BlowUp     ,MaxLengthX ,MaxLengthY;
FROM EMouse   IMPORT ShowMouse,HideMouse,GetMouseAction,Button;
FROM CoreCrt  IMPORT GotoXY;
FROM Graph    IMPORT HLine,Line,TextMode,GraphMode,InitGraph,SetVideoMode,Plot,
                     DisplayCursor;


IMPORT FIO,Graph;

TYPE MouseInf= RECORD
                 X,Y,
                 MX,MY  : CARDINAL;
                 Button : BOOLEAN;   (* Right=False,Left=TRUE *)
                 Legal  : BOOLEAN;   (* MX en MY goed? *)
                 END;
     CHARSET   =SET OF CHAR;
     TypeX=ARRAY[0..31] OF CARDINAL;
     CharP =POINTER TO Char;

PROCEDURE DoHelpScreen;

BEGIN
 GotoXY(50,05); WrStr("FontEditor V0.1");
 GotoXY(53,07); WrStr("F10 EXIT");
 GotoXY(53,08); WrStr("i         - Invert char");
 GotoXY(53,09); WrStr("SHIFT-F3  - Setup new font");
 GotoXY(53,10); WrStr("A,S,W,Z   - shift row");
 GotoXY(53,11); WrStr("a,s,w,z   - shift char");
 GotoXY(53,12); WrStr("m         - blow up chars");
 GotoXY(53,13); WrStr("o         - Preview char");
 GotoXY(53,14); WrStr("F3        - Load font");
 GotoXY(53,15); WrStr("CTRL-Home - Clear char");
 GotoXY(53,16); WrStr("F1        - Mirror char Y");
 GotoXY(53,17); WrStr("SHIFT-F1  - Mirror char X");
 GotoXY(53,18); WrStr("F2        - Symetric char Y");
 GotoXY(53,19); WrStr("SHIFT-F2  - Symetric char X");
 GotoXY(53,20); WrStr("PgUp,PgDn - Change fontnr ");
 GotoXY(53,21); WrStr("Arrow L R - inc/dec charnr");
 GotoXY(53,22); WrStr("Arrow U D - inc/dec charnr 64");
END DoHelpScreen;

CONST MyFont       = "HelvBold.Ft";     (* Default font *)
      MaxFonts     = 10;    (* Maximaal aantal fonts font 0 is gereserveerd*)
      RastCol      = 15;
      OffCol       = 10;
      MouseChar    = 19;
      MaxSize      = 0FFFFH;
      ArrU         = 4800H;
      ArrL         = 4B00H;
      ArrR         = 4D00H;
      ArrD         = 5000H;
      CtrlArrL     = 7300H;
      CtrlArrR     = 7400H;
      PgDn         = 05100H;
      PgUp         = 04900H;
      CtrlPgUp     = 8400H;
      CtrlPgDn     = 7600H;
      CtrlHome     = 7700H;
      F1           = 3B00H;
      ShiftF1      = 5400H;
      F2           = 3C00H;
      ShiftF2      = 5500H;
      F3           = 3D00H;
      ShiftF3      = 5600H;
      F4           = 3E00H;
      F10          = 4400H;
      ESC          = 1BH;

VAR Muis : MouseInf;

PROCEDURE ReadFont(VAR Fnt2:FontR;Name:ARRAY OF CHAR):CARDINAL;

VAR F          : FIO.File;
    C2         : CHAR;
    A          : CARDINAL;

(* er wordt een cardinal teruggegeven die de status aangeeft;
   0=alles OK; 1=file not found 2= verkeerd formaat 3=Font too large *)

BEGIN
 IF NOT FIO.Exists(Name) THEN
  RETURN 1;
  END;
 F:=FIO.Open(Name);
 C2:=FIO.RdChar(F);
 IF ORD(C2)>MaxLengthX THEN
  FIO.Close(F);
  RETURN 2;
  END;
 Fnt2.DX:=ORD(C2);
 C2:=FIO.RdChar(F);
 IF ORD(C2)>MaxLengthY THEN
  FIO.Close(F);
  RETURN 2;
  END;
 Fnt2.DY:=ORD(C2);
 Fnt2.NrOfChars:=ORD(FIO.RdChar(F))+ORD(FIO.RdChar(F))<<8+1;
 IF MaxSize<SizeCharsetP(Fnt2) THEN
  FIO.Close(F);
  RETURN 3;
  END;
 ALLOCATE(Fnt2.DataP,SizeCharsetP(Fnt2));
 A:=FIO.RdBin(F,Fnt2.DataP^,SizeCharsetP(Fnt2));
 FIO.Close(F);
 Fnt2.InUse:=TRUE;
 Fnt2.RX:=390 DIV Fnt2.DX;
 Fnt2.RY:=390 DIV Fnt2.DY;
 RETURN 0
END ReadFont;

PROCEDURE FindLowest(L:ARRAY OF FontR):CARDINAL;
(* Return laagste vrije fontnr, 0=geen vrij *)

VAR A,B:CARDINAL;

BEGIN
 B:=0;
 FOR A:=MaxFonts TO 1 BY -1 DO
  IF L[A].InUse=FALSE THEN
   B:=A;
   END;
  END;
RETURN B;
END FindLowest;

PROCEDURE FindHighest(L:ARRAY OF FontR):CARDINAL;
(* Vind hoogste in gebruik zijnde fontnr 0= alles leeg *)

VAR A,B  : CARDINAL;

BEGIN
 B:=0;
 FOR A:=1 TO MaxFonts-1 DO
  IF L[A].InUse THEN
   B:=A;
   END;
  END;
RETURN B;
END FindHighest;

PROCEDURE WrFntNr(Nr:CARDINAL);

BEGIN
 GotoXY(65,0);
 WrStr("FontNo:");
 WrCard(Nr,5);
END WrFntNr;

PROCEDURE PurgFont(VAR Fnt2:FontR);

BEGIN
 DEALLOCATE(Fnt2.DataP,SizeCharsetP(Fnt2));
 Fnt2.InUse:=FALSE;
END PurgFont;

PROCEDURE SaveFont(VAR Fnt2:FontR;Name:ARRAY OF CHAR):CARDINAL;

VAR F          : FIO.File;

(* er wordt een cardinal teruggegeven die de status aangeeft;
   0=alles OK; 1=Exists (evt gevolg door overwrite?) 2= error*)

BEGIN
 IF NOT FIO.Exists(Name) THEN
  RETURN 1;
  END;
 F:=FIO.Create(Name);
 FIO.WrChar(F,CHR(Fnt2.DX));
 FIO.WrChar(F,CHR(Fnt2.DY));
 FIO.WrChar(F,CHR((Fnt2.NrOfChars-1) MOD 256));
 FIO.WrChar(F,CHR((Fnt2.NrOfChars-1) >> 256));
 FIO.WrBin(F,Fnt2.DataP^,SizeCharsetP(Fnt2));
 FIO.Close(F);
 RETURN 0
END SaveFont;

PROCEDURE Raster(Dat:FontR);

VAR B:CARDINAL;

BEGIN
 WITH Dat DO
  FOR B:=0 TO DX DO
   Line(RX*B+X,Y,RX*B+X,DY*RY+Y,RastCol);
   END;
  FOR B:=0 TO DY DO
   HLine(X,Y+B*RY,X+DX*RX,RastCol);
   END;
  END;
END Raster;

VAR Fnt        : ARRAY[0..MaxFonts] OF FontR;
    R,R2       : CARDINAL;
    Ch,Ch2     : CharP;
    MX,MY,                      (* Idem, maar dan mbv de muis gerekend
                                   Dit is geen positie in pixels, maar wordt
                                    bepaald door RX en RY *)
    Font,                       (* FontNr dat geedit wordt *)
    ChNr       : CARDINAL;
    A,B,C,D,E,G: CARDINAL;
    Or         : ARRAY[0..20] OF CHAR;
    F          : FIO.File;
    Fl         : BOOLEAN;

PROCEDURE FindGoodBack():CARDINAL;

VAR FA :CARDINAL;

BEGIN
 FA:= Font;
   LOOP
    IF FA<1 THEN
     RETURN FA
     END;
    IF Fnt[FA-1].InUse THEN
     ChNr:=0;
     RETURN FA-1;
     END;
    DEC (FA);
    END;
END FindGoodBack;

PROCEDURE FindGoodForw():CARDINAL;

VAR FA,FB:CARDINAL;

BEGIN
 FA:=Font+1;
 FB:=FindHighest(Fnt);
 LOOP
  IF FA>FB THEN
   RETURN FB;
   END;
  IF Fnt[FA].InUse THEN
   ChNr:=0;
   RETURN FA
   END;
   INC(FA);
  END;
END FindGoodForw;

PROCEDURE SetupFont(X1,Y1:CARDINAL;VAR Card,Fon,Nr:CARDINAL;VAR Fn:ARRAY OF FontR):CARDINAL;

VAR Ol :CARDINAL;

BEGIN
 Ol:=FindLowest(Fn);
 IF Ol=0 THEN
  RETURN 1;
  END;
 Fon:=Ol;
 Fn[Fon].DX:=X1;
 Fn[Fon].DY:=Y1;
 Fn[Fon].NrOfChars:=Card;
 ALLOCATE(Fn[Fon].DataP,SizeCharsetP(Fn[Fon]));
 Fill(ADR(Fn[Fon].DataP^),SizeCharsetP(Fn[Fon]),0);
 Fn[Fon].InUse:=TRUE;
 Fn[Fon].RX:=390 DIV Fn[Fon].DX;
 Fn[Fon].RY:=390 DIV Fn[Fon].DY;
 Raster(Fn[Fon]);
 ChNr:=0;
 GetChar(Fnt[Fon],ChNr,Ch^);
 GDisplChar(Ch^,Fnt[Fon]);
 RETURN 1;
END SetupFont;

PROCEDURE GetKey():CARDINAL;

(* Special version of ELib.GetKey; It translates mouse actions to
    characters *)

VAR GA  : CARDINAL;
    Fl  : BOOLEAN;
    Da  : Button;

BEGIN
 LOOP
  IF KeyPressed()=TRUE THEN
   GA:=ORD(RdKey());
   EXIT
   END;
  GetMouseAction( Da, Muis.X, Muis.Y );
  Muis.MX:=Fnt[Font].DX-(Muis.X-Fnt[Font].X) DIV Fnt[Font].RX-1;
  Muis.MY:=(Muis.Y-Fnt[Font].Y) DIV Fnt[Font].RY;
  Muis.Legal:= (Muis.MX<Fnt[Font].DX) AND (Muis.MY<Fnt[Font].DY);
  IF ((Muis.Legal) AND (Da=LeftB)) AND (Muis.MX IN Ch^[Muis.MY]) THEN
   Da:=Da-LeftB;
   END;
  IF ((Muis.Legal) AND (Da=RightB)) AND  NOT(Muis.MX IN Ch^[Muis.MY]) THEN
   Da:=Da-RightB;
   END;
  IF Da=RightB THEN
   Muis.Button:=FALSE;
   GA:=MouseChar;
   EXIT;
   END;
  IF Da=LeftB THEN
   Muis.Button:=TRUE;
   GA:=MouseChar;
   EXIT;
   END;
  END;
 IF GA=0 THEN (* functie toets?*)
  GA:=ORD(RdKey())<<8; (* dan waarde functie maal 256*)
  END;
 RETURN GA;
END GetKey;

BEGIN
 (* INIT Part *)
 ALLOCATE(Ch,SIZE(Char));
 ALLOCATE(Ch2,SIZE(Char));
 Font:=0;
 FOR R:=0 TO 9 DO
  Fnt[R].InUse:=FALSE;
  Fnt[R].X:=10;
  Fnt[R].Y:=10;
  END;
 R:= ReadFont(Fnt[Font],MyFont);
 IF R>0 THEN
  HALT;
  END;
 IF NOT SetVideoMode(18) THEN (* VGA 640x480? *)
  HALT;
  END;
 InitGraph;
 GraphMode;
 Raster(Fnt[Font]);
 DoHelpScreen;
 ChNr:=65;
 GetChar(Fnt[Font],ChNr,Ch^);
 GDisplChar(Ch^,Fnt[Font]);
 WrFntNr(Font);
 LOOP
  ShowMouse;
  R:=GetKey();
  HideMouse;
  CASE R OF
   | F10          : EXIT
   | MouseChar    : IF Muis.Legal THEN
                     IF Muis.Button THEN
                      INCL(Ch^[Muis.MY],Muis.MX);
                     ELSE
                      EXCL(Ch^[Muis.MY],Muis.MX);
                      END;
                     GDisplRow(Fnt[Font],Muis.MY,Ch^[Muis.MY]);
                     END;
   | ORD("i")     : IF Muis.Legal THEN
                     FOR A:=0 TO Fnt[Font].DY-1 DO
                      FOR B:=0 TO Fnt[Font].DX-1 DO
                       IF B IN Ch^[A] THEN
                        EXCL(Ch^[A],B);
                       ELSE
                        INCL(Ch^[A],B);
                        END;
                       END;
                      END;
                     END;
                    GDisplChar(Ch^,Fnt[Font]);
   | ShiftF3      : GotoXY (60,1);
                    Fl:=DisplayCursor(TRUE);
                    WrStr("DimX ? ");
                    A:=RdCard();
                    GotoXY(60,2);
                    WrStr("DimY ? ");
                    B:=RdCard();
                    GotoXY(60,3);
                    WrStr("No characters?");
                    C:=RdCard();
                    GotoXY (60,1); WrCharRep(" ",19);
                    GotoXY (60,2); WrCharRep(" ",19);
                    GotoXY (60,3); WrCharRep(" ",19);
                    Fl:=DisplayCursor(FALSE);
                    D:=SetupFont(A,B,C,Font,ChNr,Fnt);
                    WrFntNr(Font);
   | ORD("A")     : IF Muis.Legal THEN
                     ShiftLRow(Fnt[Font],Ch^[Muis.MY]);
                     GDisplRow(Fnt[Font],Muis.MY,Ch^[Muis.MY]);
                     END;
   | ORD("S")     : IF Muis.Legal THEN
                     ShiftRRow(Fnt[Font],Ch^[Muis.MY]);;
                     GDisplRow(Fnt[Font],Muis.MY,Ch^[Muis.MY]);
                     END;
   | ORD("W")     : IF Muis.Legal THEN
                     ShiftUCol(Fnt[Font],Ch^,Muis.MX);
                     GDisplChar(Ch^,Fnt[Font]);
                     END;
   | ORD("Z")     : IF Muis.Legal THEN
                     ShiftDCol(Fnt[Font],Ch^,Muis.MX);
                     GDisplChar(Ch^,Fnt[Font]);
                     END;
   | F3           : GotoXY(60,1); WrStr("Name?");
                    GotoXY(60,2); Fl:=DisplayCursor(TRUE);  RdStr(Or);
                    GotoXY(60,1); WrCharRep(" ",19);
                    GotoXY(60,2); WrCharRep(" ",19);
                    Fl:=DisplayCursor(FALSE);
                    A:=ReadFont(Fnt[Font],Or);
   | CtrlHome     : Fill(ADR(Ch^),(MaxLengthX*MaxLengthY) DIV Wid,0);
                    GDisplChar(Ch^,Fnt[Font]);
   | F1           : MirrorChar(Fnt[Font],Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
   | ShiftF1      : MirrorX(Fnt[Font],Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
   | ShiftF2      : SymX(Fnt[Font],Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
   | F2           : SymCharY(Fnt[Font],Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
   | ESC          : GetChar(Fnt[Font],ChNr,Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
   | ORD("w")     : ShiftU(Fnt[Font],Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
   | ORD("m")     : StoreChar(Fnt[Font],E,Ch^);
                    G:=Font;
                    Fl:=DisplayCursor(TRUE);
                    GotoXY(60,1); WrStr("FactorX :");   A:=RdCard();
                    GotoXY(60,2); WrStr("FactorY :");   B:=RdCard();
                    GotoXY(60,3); WrStr("No Chars:");   C:=RdCard();
                    GotoXY(60,1); WrCharRep(" ",19);
                    GotoXY(60,2); WrCharRep(" ",19);
                    GotoXY(60,3); WrCharRep(" ",19);
                    Fl:=DisplayCursor(FALSE);
                    IF (A*Fnt[Font].DX<MaxLengthX+1) AND (B*Fnt[Font].DY<MaxLengthY+1) THEN
                     D:=SetupFont(A*Fnt[Font].DX,B*Fnt[Font].DY,C,Font,ChNr,Fnt);
                     FOR E:=0 TO C-1 DO
                      GetChar(Fnt[G],E,Ch^);
                      BlowUp(Fnt[G],Ch^,A,B);
                      StoreChar(Fnt[Font],E,Ch^);
                      END;
                     Fnt[Font].NrOfChars:=E-1;
                    END;
                    GDisplChar(Ch^,Fnt[Font]);
   | ORD("z")     : ShiftD(Fnt[Font],Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
   | ORD("a")     : ShiftL(Fnt[Font],Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
   | ORD("s")     : ShiftR(Fnt[Font],Ch^);
                    GDisplChar(Ch^,Fnt[Font])
   | ORD("o")     : A:=MaxLengthX DIV Fnt[Font].DX-2;
                    IF A> (MaxLengthY DIV Fnt[Font].DY-2)THEN
                     A:=MaxLengthY DIV Fnt[Font].DY-2;
                     END;
                    FOR B:=0 TO ((Fnt[Font].DY)*A-1) DO
                     FOR C:=0 TO ((Fnt[Font].DX)*A-1) DO
                       IF ((Fnt[Font].DX-1)-(C) DIV A) IN Ch^[B DIV A] THEN
                        Plot(500+C,200+B,RastCol);
                       ELSE
                        Plot(500+C,200+B,OffCol);
                        END;
                       END;
                      END;
  | PgUp          : StoreChar(Fnt[Font],ChNr,Ch^);
                    Font:=FindGoodBack();
                    GetChar(Fnt[Font],ChNr,Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
                    Raster(Fnt[Font]);
                    WrFntNr(Font);
  | PgDn          : StoreChar(Fnt[Font],ChNr,Ch^);
                    Font:=FindGoodForw();
                    GetChar(Fnt[Font],ChNr,Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
                    Raster(Fnt[Font]);
                    WrFntNr(Font);
  | CtrlArrL      : IF ChNr>4 THEN
                     StoreChar(Fnt[Font],ChNr,Ch^);
                     DEC(ChNr,5);
                     GetChar(Fnt[Font],ChNr,Ch^);
                     GDisplChar(Ch^,Fnt[Font]);
                     END;
  | CtrlArrR      : IF ChNr<(Fnt[Font].NrOfChars-5) THEN
                     StoreChar(Fnt[Font],ChNr,Ch^);
                     INC(ChNr,5);
                     GetChar(Fnt[Font],ChNr,Ch^);
                     GDisplChar(Ch^,Fnt[Font]);
                     END;
  | ArrR          : IF ChNr<(Fnt[Font].NrOfChars-1) THEN
                     StoreChar(Fnt[Font],ChNr,Ch^);
                     INC(ChNr);
                     GetChar(Fnt[Font],ChNr,Ch^);
                     GDisplChar(Ch^,Fnt[Font]);
                     END;
  | ArrL          : IF ChNr>0 THEN
                     StoreChar(Fnt[Font],ChNr,Ch^);
                     DEC(ChNr);
                     GetChar(Fnt[Font],ChNr,Ch^);
                     GDisplChar(Ch^,Fnt[Font]);
                     END;
  | ArrU          : IF ChNr>63 THEN
                     StoreChar(Fnt[Font],ChNr,Ch^);
                     DEC(ChNr,64);
                     GetChar(Fnt[Font],ChNr,Ch^);
                     GDisplChar(Ch^,Fnt[Font]);
                     END;
  | ArrD          : IF ChNr<(Fnt[Font].NrOfChars-64) THEN
                     StoreChar(Fnt[Font],ChNr,Ch^);
                     INC(ChNr,64);
                     GetChar(Fnt[Font],ChNr,Ch^);
                     GDisplChar(Ch^,Fnt[Font]);
                     END;
  | CtrlPgUp      : ChNr:=0;
                    GetChar(Fnt[Font],ChNr,Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
  | CtrlPgDn      : ChNr:=Fnt[Font].NrOfChars;
                    GetChar(Fnt[Font],ChNr,Ch^);
                    GDisplChar(Ch^,Fnt[Font]);
    END;
   END;
  FOR A:=0 TO 10 DO
   IF Fnt[A].InUse THEN
    DEALLOCATE(Fnt[A].DataP,SizeCharsetP(Fnt[A]));
    END;
  END;
 DEALLOCATE(Ch,SIZE(Char));
 DEALLOCATE(Ch2,SIZE(Char));
 IF NOT SetVideoMode(3) THEN (* VGA 640x480? *)
  HALT;
  END;
END FontEditor.