MODULE HelpComp;
(* Helpfiles compiler, XTDLIB package (C) 1997 by Marco van de Voort,

Originally meant to mimic the TopSpeed help system, because
- I was rather satified about the possibilities of both TopSpeed .HTX format
   and the output (in the IDE)
- It saved learning two different formats sources file.
- I could make a browser for my .HTX file, for the people without TSMKHELP.

The module is slow. (The helpfile compiler, not the helpsystem!) Quite a
  bit slower than TopSpeeds. I don't know what the origin of this
  slowlyness (opposed to TopSpeed) is. It's partially the DJARC system
  (better compression), and maybe TopSpeed only passes once, or reads the
  entire file into memory and passes twice? (So only one time diskaccess)
  The TopSpeed programmers HAD access to an extender.

If you have a slow 386, you can turn of compression, and/or change the
LabelExists procedure to make use of the collected hashes, instead of
Str.Compares.(tested the Str.Compare version on a 386DX, it's fast enough I
think)

Do not run in small or medium memorymodel! Too much memory required!
(You'll get a nice NearHeapAllocate runtimeerror, no permanent damage)
*)

IMPORT FIO,IO;
FROM Str IMPORT Length,ItemS,Copy,CharPos,Delete,CHARSET,Insert,Compare,Caps,
                Slice,RCharPos;
FROM ELib IMPORT KillChar,KillBChar,KillChrTot,RemoveExtension,
                 ReplaceChar,ChangeExtension;
FROM Lib IMPORT HashString,Move,Delay,Fill,ParamCount,ParamStr;
FROM Storage IMPORT ALLOCATE,HeapTotalAvail,MainHeap;
FROM DJArc  IMPORT Packer;
FROM CoreEFIO IMPORT Wr16,Wr24,Wr32;

CONST MaxLab=1300;

TYPE LabStr     = ARRAY[0..39] OF CHAR;
     Label      = RECORD
                   Ind     : LONGCARD; (* Index in File*)
                   HashName: CARDINAL; (* HashValue "Label.Label" *)
                   Label   : LabStr;   (* Ascii name.= "    " *)
                   Used    : BOOLEAN;  (* Label referenced in this helpfile?*)
                   END;
     AliasStr   = LabStr;
     AliasArr   = ARRAY[0..MaxLab] OF AliasStr;
     AliasPtr   = POINTER TO AliasArr;
     LabArr     = ARRAY[0..MaxLab] OF Label;
     LabPtr     = POINTER TO LabArr;
     Buffer     = ARRAY[0..31000] OF BYTE;
     BufPtr     = POINTER TO Buffer;
     Redirect   = RECORD
                   Label : CARDINAL;
                   HelpFile,
                   ForeignLabel : ARRAY[0..20] OF CHAR;
                   END;
     RedirectArr   = ARRAY[0..1000] OF Redirect;
     RedirPnt      = POINTER TO RedirectArr;

CONST EscS=166;
      Min=40;
      Range=255-40;

VAR Labs        : CARDINAL;
    RedNr       : CARDINAL;
    BufInd      : CARDINAL;
    Index ,Ind2 : LONGCARD;
    L           : LabPtr;
    Red         : RedirPnt;
    Buf,Buf2    : BufPtr;
    Alias       : AliasPtr;
    F,F2        : FIO.File;
    F2Open      : BOOLEAN;
    LineNr      : LONGCARD;
    Compress    : BOOLEAN;
    B,
    B2          : ARRAY[0..4095] OF BYTE;
    CalcCadre   : BOOLEAN;
    Cadre       : BOOLEAN;


PROCEDURE Error(S:ARRAY OF CHAR);
(* Error in source. HALT*)

BEGIN
 IF LineNr # 0 THEN
  FIO.Close(F);
  IF F2Open THEN
   FIO.Close(F2);
   END;
  IO.WrStr("Error in Line "); IO.WrLngCard(LineNr,0); IO.WrLn;IO.WrLn;
  END;
 IO.WrStr(S); IO.WrLn;IO.WrLn;HALT;
END Error;

PROCEDURE ReLabel(Lab1,Lab2:LONGCARD);
(* Relabel. If a label index is changed because of compression, this
 procedure is called which changes the old (uncompressed, so reproducable
 in pass 2) by new compressed index in the file. *)

VAR A :CARDINAL;

BEGIN
 IF (Lab1 # Lab2)  THEN
 FOR A:=0 TO Labs-1 DO
  IF L^[A].Ind=Lab1 THEN
   L^[A].Ind:=Lab2;
   END;
  END;
  END;
END ReLabel;

PROCEDURE DisplayMem();
(* Programmed to look how much memory was required. But memory usage is low,
    not really necessary to watch memory*)

BEGIN
 IO.WrStr("Memory available : ");
 IO.WrLngCard(LONGCARD(HeapTotalAvail(MainHeap))*16,10); IO.WrLn;
END DisplayMem;

PROCEDURE LabelExists(VAR S:ARRAY OF CHAR):CARDINAL;

VAR A :CARDINAL;
    S2:ARRAY[0..100] OF CHAR;

BEGIN
 KillChar(S,CHARSET{"!"," "});
 KillBChar(S,CHARSET{":"," "});
 Copy(S2,S);
 KillChrTot(S2,CHARSET{"!"," "});

 IF Labs>0 THEN
  FOR A:=0 TO Labs-1 DO
   IF Compare(S2,L^[A].Label)=0 THEN
    IF Length(S2)<Length(S) THEN
     Copy (Alias^[A],S);
     END;
    RETURN A;
    END;
   END;
  END;
  RETURN MAX(CARDINAL);
END LabelExists;

PROCEDURE PreprocessLine(VAR S :ARRAY OF CHAR);
(* Removes anything between < and > and
  after > until next , or end of string*)

VAR A,B,Len : CARDINAL;
    S2      : ARRAY[0..100] OF CHAR;

BEGIN
 Len:=Length(S);
 LOOP
  A:=CharPos(S,">");                   (* 12345 *)
  IF A= MAX(CARDINAL) THEN             (* >hhh, *)
   EXIT
   END;
   S[A]:=CHR(146);
  B:=CharPos(S,"<");

  IF A <B THEN
   B:=CharPos(S,",");
   S[B]:="";
   S[A]:=CHR(148);
  ELSE
   S[A]:=CHR(146);
   END;
  INC(A);
  IF A>Len THEN
   EXIT
   END;
  END;
 ReplaceChar(S,"",",");
 ReplaceChar(S,CHR(146),"<");
END PreprocessLine;

PROCEDURE DoLabelLine(VAR S: ARRAY OF CHAR);

VAR S2,S3:ARRAY[0..500] OF CHAR;
    A  : CARDINAL;

BEGIN
 PreprocessLine(S);
 LOOP
  ItemS(S2,S,",",0);
  IF S2[0]=CHR(0) THEN
   EXIT
   END;
  WITH L^[Labs] DO
  IF CharPos(S2,CHR(147))=MAX(CARDINAL) THEN
   A:=CharPos(S2,CHR(148));
   S3:="";
   IF A# MAX(CARDINAL) THEN
    Slice(S3,S2,A+1,100);
    Delete(S2,A,100);
    END;
   IF LabelExists(S2)#MAX(CARDINAL) THEN
   Error("Label already exists");
   ELSE
    KillChrTot(S2,CHARSET{" "});
    Copy(Label,S2);
    Ind:=Index;
    HashName:=HashString(S2,MAX(CARDINAL));
    Used:=FALSE;
    END;
   IF S3[0]#CHR(0) THEN
    A:=CharPos(S3,"|");
    Slice(S2,S3,A+1,100);
    Delete(S3,A,100);
    Copy(Red^[RedNr].ForeignLabel,S2);
    Copy(Red^[RedNr].HelpFile,S3);
    Red^[RedNr].Label:=Labs;
    INC (RedNr);
    END;
   END;
  END;
  INC(Labs);
  S[0]:=" ";
  A:=CharPos(S,",");
  IF A=MAX(CARDINAL) THEN
   S[0]:=CHR(0);
  ELSE
   Delete(S,0,A+1);
   END;
  END;
END DoLabelLine;

PROCEDURE StripSpaces(VAR S :ARRAY OF CHAR;C:CHAR);
(* Adapted SubComp procedure; encodes spaces into an ansi like
escape code. *)

VAR A,B,Len : CARDINAL;
    Code1   : CARDINAL;


BEGIN
 CASE C OF
  | " " : Code1:=EscS+1;
  | "" : Code1:=EscS+4;
  END;
 Len:=Length(S);
 IF Len=0 THEN
  RETURN;
  END;
 A:=0;
 LOOP
  IF A>(Len-1) THEN
  EXIT
  END;
  IF (S[A]=C) THEN
   B:=1;
   LOOP
    IF (S[A+B] # C) OR ((A+B)>Len) THEN
     EXIT
     END;
    INC(B);
    END;
   IF CalcCadre THEN
    CalcCadre:=FALSE;
    IF B>1 THEN
     DEC(B);
     Delete(S,A+1,1);
     END;
    END;
   IF (B=3) OR (B=2) THEN

    S[A]:=CHR(Code1+B-2);
    Delete(S,A+1,B-1);
    DEC(Len,B-1);
   ELSIF B>3 THEN
    S[A]:=CHR(Code1+2);
    S[A+1]:=CHR(Code1+B);
    Delete(S,A+2,B-2);
    DEC(Len,B-2);
    END;
   END;
  INC(A);
  END;
END StripSpaces;

PROCEDURE PatchFirstCHR2(VAR S : ARRAY OF CHAR;A:CARDINAL):CARDINAL;

VAR B,Len : CARDINAL;

BEGIN
 Len:=Length(S);
 IF S[A+1]=" " THEN
  B:=1;
  LOOP
   IF (S[A+1+B] # " ") OR ((A+B)>Len) THEN
   EXIT
   END;
  INC(B);
  END;
  S[A]:=" ";
  S[A+B]:=CHR(2);
  RETURN A+B;
  END;
 RETURN A;
END PatchFirstCHR2;

PROCEDURE PatchSecCHR2(VAR S : ARRAY OF CHAR;A,B:CARDINAL):CARDINAL;

VAR X,Len : CARDINAL;

BEGIN
 IF S[B-1]=" " THEN
  Len:=Length(S);
  X:=B-1;
  LOOP
   IF X<A THEN
    EXIT
    END;
   IF S[X-1]#" " THEN
    EXIT;
    END;
   DEC(X);
   END;
   S[B]:=" ";
   S[X]:=CHR(2);
   RETURN X;
   END;
 RETURN B;
END PatchSecCHR2;



PROCEDURE PatchLine(VAR S:ARRAY OF CHAR;DoLabel:BOOLEAN);
(* Tests for labels, and kills them ( *)

VAR A,A2 : CARDINAL;
    LabF : ARRAY[0..64] OF CHAR;
    A3   : CARDINAL;

BEGIN
 IF (S[0]=CHR(218)) AND (Length(S)<2)THEN
  Cadre:=TRUE;
  END;
 IF (S[0]=CHR(192)) AND (Length(S)<2)THEN
  Cadre:=FALSE;
  END;
 CalcCadre:=Cadre;
 LOOP
  A:=CharPos(S,CHR(2));

  IF A=MAX(CARDINAL) THEN
   RETURN;
   END;
  A:=PatchFirstCHR2(S,A);
  S[A]:=CHR(EscS);
  A2:=CharPos(S,CHR(2));
  IF A2=MAX(CARDINAL) THEN
   A2:=Length(S);
   END;
  A2:=PatchSecCHR2(S,A,A2);
  S[A2]:="}";
  Slice(LabF,S,A+1,A2-A-1);                (* 12345*)
  IF (A2-A)>2 THEN                         (* #AHA#*)
   Delete(S,A+1,A2-A-2);
  ELSIF (A2-A)=2 THEN
   Insert(S,CHR(147),A+1);
  ELSE
   Insert(S,CHR(147)+CHR(147),A+1);
   END;
  IF DoLabel THEN
   PreprocessLine(LabF);
   A3:=LabelExists(LabF);
   IF A3=MAX(CARDINAL) THEN
    Error("Label not found");
   ELSE
    S[A+1]:=CHR(Min+A3 MOD Range);
    S[A+2]:=CHR(Min+A3 DIV Range);
    L^[A3].Used:=TRUE;
    END;
   END;
  END;
END PatchLine;

PROCEDURE RemoveTrailing(VAR S: ARRAY OF CHAR);
(* Remove trailing unnecessary characters.*)

VAR Len : CARDINAL;

BEGIN
 Len:=Length(S);
 IF S[Len-1] IN CHARSET{CHR(2),CHR(3)} THEN
  Delete(S,Len-1,1);
  END;
 KillBChar(S,CHARSET{" "});
END RemoveTrailing;

PROCEDURE DoTilde(VAR S :ARRAY OF CHAR);

VAR A,B,C:CARDINAL;

BEGIN
 LOOP
  A:=CharPos(S,"~");
  IF A=MAX(CARDINAL) THEN
   EXIT;
   END;
  B:=A+1;
  C:=0;
  LOOP
   IF (ORD(S[B])<48) OR (ORD(S[B])>57) THEN
    EXIT
    END;
   C:=C*10+ORD(S[B])-48;
   INC(B);
   END;
  IF B=(A+1) THEN
   RETURN;
(*   Error(" Tilde (~) without code!"); *)
   END;
  S[A]:=CHR(C);
  DEC(B,A+1);
  Delete(S,A+1,B);
  END;

END DoTilde;

PROCEDURE ProcessLine(VAR S: ARRAY OF CHAR;DoLabel:BOOLEAN);

BEGIN
 IF S[0]="!" THEN
   INC(Index,2);
 ELSE
  PatchLine(S,DoLabel);         (* Process labels *)
  RemoveTrailing(S);    (* Remove trailing characters that are obsolete*)
  StripSpaces(S," ");       (* Encode multiple spaces after each other.*)
  StripSpaces(S,"");       (* And line segments.*)
  DoTilde(S);               (* Tokenize with tildes escape highascii*)
  INC(Index,LONGCARD(Length(S))+1); (* +1: a line separator.*)
  END;
END ProcessLine;

PROCEDURE DumpLabels;

TYPE BARR=ARRAY[0..3] OF BYTE;
     BPtr= POINTER TO BARR;

VAR A : CARDINAL;
    B : CARDINAL;

BEGIN
 BufInd:=0;
 FOR A:=0 TO Labs-1 DO     (* Put all labels after each other separated by
                               CHR(145); *)
  IF Alias^[A][0]# CHR(0) THEN
   B:=Length(Alias^[A]);
   Move(ADR(Alias^[A]),ADR(Buf^[BufInd]),B);
  ELSE
   B:=Length(L^[A].Label);
   Move(ADR(L^[A].Label),ADR(Buf^[BufInd]),B);
   END;

  INC(BufInd,B);
  Buf^[BufInd]:=CHR(145);
  INC(BufInd);
  END;
 IF Compress THEN
  B:=Packer(BufInd,ADR(Buf^[0]),ADR(Buf2^[0]));
 ELSE
  B:=BufInd;
  Move(ADR(Buf^[0]),ADR(Buf2^[0]),B);
  END;
 Wr16(F2,Labs);
 Wr16(F2,BufInd);       (* unpacked size needed to decrunch *)
 Wr16(F2,B);
 FOR A:= 0 TO Labs-1 DO (* Write "labs" 3-byte index values *)
  (*3986*)
 (* 3 bytes of longcard written, I doubt the helpfile> 16 MB*)
  Wr24(F2,L^[A].Ind);
  END;
 FIO.WrBin(F2,Buf2^[0],B); (* Write the labels*)
 Wr16(F2,RedNr);
 IF RedNr>0 THEN
  BufInd:=0;
  FOR A:=0 TO RedNr-1 DO     (* Put all labels after each other separated by
                                CHR(145); *)
   B:=Length(Red^[A].HelpFile);
   Move(ADR(Red^[A].HelpFile),ADR(Buf^[BufInd]),B);
   INC(BufInd,B);
   Buf^[BufInd]:=CHR(146);
   INC(BufInd);
   B:=Length(Red^[A].ForeignLabel);
   Move(ADR(Red^[A].ForeignLabel),ADR(Buf^[BufInd]),B);
   INC(BufInd,B);
   Buf^[BufInd]:=CHR(145);
   INC(BufInd);
   END;
  INC(BufInd);
  INC(BufInd);
  IF Compress THEN
   B:=Packer(BufInd,ADR(Buf^[0]),ADR(Buf2^[0]));
  ELSE
   B:=BufInd;
   Move(ADR(Buf^[0]),ADR(Buf2^[0]),B);
   END;

  Wr16(F2,BufInd);       (* unpacked size needed to decrunch *)
  Wr16(F2,B);
  FOR A:= 0 TO RedNr-1 DO (* Write "labs" 3-byte index values *)
   (*3986*)
  (* 3 bytes of longcard written, I doubt the helpfile> 16 MB*)
   Wr16(F2,Red^[A].Label);
   END;
  FIO.WrBin(F2,Buf2^[0],B); (* Write the labels*)
  END;
END DumpLabels;

PROCEDURE BuildIDX(S1:FIO.PathStr);

VAR
    S    : ARRAY[0..500] OF CHAR;
    CompSize      : CARDINAL;

BEGIN
 NEW(L);
 Labs:=0; Index:=0;
 F:=FIO.Open(S1);
 FIO.AssignBuffer(F,B);
 LOOP
  FIO.RdStr(F,S);
  INC(LineNr);
  IF (LineNr AND 255)=0 THEN
   IO.WrChar(".");
   END;
  IF FIO.EOF THEN
   EXIT
   END;
  IF (S[0]="!") AND (Length(S)>1) THEN
   DoLabelLine(S);
  ELSE
   ProcessLine(S,FALSE);
   END;
  END;
  FIO.Close(F);
  IO.WrStr(" found "); IO.WrCard(Labs,0); IO.WrStr(" Labels");
END BuildIDX;

PROCEDURE CompileHelp(Name:FIO.PathStr);

VAR N2 : FIO.PathStr;
    S      : ARRAY[0..500] OF CHAR;

    CompSize:CARDINAL;
    OldIndex : LONGCARD;

PROCEDURE FlushHelp;

BEGIN
    IF Compress THEN
     CompSize:=Packer(BufInd,ADR(Buf^[0]),ADR(Buf2^[0]));
    ELSE
     CompSize:=BufInd;
     Move(ADR(Buf^[0]),ADR(Buf2^[0]),CompSize);
     END;
    ReLabel(OldIndex,Ind2);
    INC(Ind2,LONGCARD(CompSize)+4); (* +4 for the following wr16 writes*)
    OldIndex:=Index;

    Wr16(F2,BufInd);
    Wr16(F2,CompSize);
    FIO.WrBin(F2,Buf2^[0],CompSize);
    BufInd:=0;
END FlushHelp;

BEGIN
 N2:=Name; Index:=0; Ind2:=0;BufInd:=0;
 ChangeExtension(N2,"hlp");
 F:=FIO.Open(Name);
 F2:=FIO.Create(N2); F2Open:=TRUE;
 FIO.WrCharRep(F2," ",16);

 N2:=Name; Index:=0; Ind2:=0;BufInd:=0;

 FIO.AssignBuffer(F2,B2);
 FIO.AssignBuffer(F,B);
 OldIndex:=0;
 LOOP
  FIO.RdStr(F,S);
  INC(LineNr);
  IF (LineNr AND 255)=0 THEN
   IO.WrChar(".");
   END;
  IF FIO.EOF THEN
   EXIT
   END;
  IF (S[0]="!") AND (Length(S)>1) THEN

   IF BufInd>0 THEN
    FlushHelp;
    END;
  ELSE
   ProcessLine(S,TRUE);
   Move(ADR(S),ADR(Buf^[BufInd]),Length(S));
   INC(BufInd,Length(S));
   Buf^[BufInd]:=CHR(13);
   INC(BufInd);
   END;
  END;
 FlushHelp;
 FIO.Close(F);

END CompileHelp;

PROCEDURE CreateDef(DefName:FIO.PathStr);

VAR A,B, Wr :CARDINAL;
    Def2 : FIO.PathStr;
    S    : ARRAY[0..39] OF CHAR;
    Flag : BOOLEAN;

PROCEDURE CutGarbadge(C:CHAR);
BEGIN
  B:=CharPos(S,C);
  IF B # MAX(CARDINAL) THEN
   S[B]:=CHR("1");
   S[B+1]:=CHR(0);
   END;
END CutGarbadge;

BEGIN
 ChangeExtension(DefName,"DEF");
 Caps(DefName);
 A:=RCharPos(DefName,"\");
 IF A # MAX(CARDINAL) THEN
  Slice(Def2,DefName,A+1,1000); (* Untill end of char*)
 ELSE
  Copy (Def2,DefName);
  END;
 RemoveExtension(Def2);
 A:=CharPos(Def2,".");
 IF A # MAX(CARDINAL) THEN
  Def2[A]:=CHR(0);
  END;
 F:=FIO.Create(DefName);
 FIO.WrStr(F,"DEFINITION MODULE ");
 FIO.WrStr(F,Def2);    FIO.WrChar(F,";");           FIO.WrLn(F);
 FIO.WrLn(F);
 FIO.WrStr(F,"CONST"); FIO.WrLn(F);
 Wr:=0;
 FOR A:=0 TO Labs-1 DO
  FIO.WrChar(F," ");
  Copy(S,L^[A].Label);
  ReplaceChar(S,"-","_");  ReplaceChar(S,"'","_");
  ReplaceChar(S,"+","_"); KillChrTot(S,CHARSET{"."});

  CutGarbadge("<");  CutGarbadge("(");
  CutGarbadge("/");  CutGarbadge(":");

  KillBChar(S,CHARSET{")","+",".",">","="});
  IF Length(S)>14 THEN
   S[14]:=CHR(0);
   END;
  Flag:=FALSE;
  IF Length(S)>17 THEN
   IF Wr=2 THEN
    FIO.WrLn(F);
    FIO.WrChar(F," ");
    END;
   IF Wr=1 THEN
    IF Length(S)>34 THEN
     FIO.WrLn(F);
     FIO.WrChar(F," ");
     END;
    END;
    FIO.WrStrAdj(F,S,-17);
    FIO.WrChar(F," ");
    IF Wr=0 THEN
     Wr:=1;
    ELSE
     Flag:=TRUE;
     END;
  ELSE
   FIO.WrStrAdj(F,S,-17);
   END;
  FIO.WrStr(F,"=");
  FIO.WrCard(F,A,6);
  FIO.WrStr(F,";");
  INC(Wr);
  IF (Wr=3) OR Flag THEN
   FIO.WrLn(F);
   Wr:=0;
   END;
  END;
 FIO.WrLn(F);
 FIO.WrStr(F,"END ");
 FIO.WrStr(F,Def2);
 FIO.WrChar(F,"."); FIO.WrLn(F);
 FIO.Close(F);
END CreateDef;

VAR Name : FIO.PathStr;
    A    : CARDINAL;

CONST CrLf=CHR(13)+CHR(10);
      Header="HelpComp v0.01, compile .HTX helpresources files to .HLP for HELPSYS,"+CrLf+CrLf;
      Usage= "Usage : HelpComp <Filename>"+CrLf+CrLf;

BEGIN
 F2Open:=FALSE;
 IO.WrStr(Header);
 IF ParamCount()<1 THEN
  IO.WrStr(Usage);
  HALT;
  END;
 DisplayMem;
 ParamStr(Name,1);
 IF NOT FIO.Exists(Name) THEN
  IO.WrStr(Usage);
  HALT;
  END;
 Compress:=TRUE;
 Cadre:=FALSE;
 NEW(Buf);   NEW(Buf2); NEW(Alias); Fill(ADR(Alias^),SIZE(AliasArr),0);
 NEW(Red);
 BufInd:=0; RedNr:=0;
 IO.WrStr("First pass, gathering labels    : ");
 BuildIDX(Name);
 IO.WrLn;
 LineNr:=0;
 IF Labs<1 THEN
  Error(" No labels in Helpfile!");
  END;
 IO.WrStr("Second pass, compiling the file : ");
 CompileHelp(Name);
 DumpLabels;
 FIO.Seek(F2,0);
 Wr32(F2,Ind2);
 FIO.WrChar(F2,CHR(Compress));
 FIO.WrChar(F2,CHR(255));
 FIO.Close(F2); F2Open:=FALSE;
 IO.WrLn;
 CreateDef(Name);
 IO.WrStrAdj("Uncompressed size data : ",25);  IO.WrLngCard(Index,15); IO.WrLn;
 IO.WrStrAdj("compressed size data : ",25);  IO.WrLngCard(Ind2,15); IO.WrLn;
 ChangeExtension(Name,"err");
 F:=FIO.Create(Name);
 FOR A:=0 TO Labs-1 DO
  IF NOT L^[A].Used THEN
   FIO.WrStr(F,L^[A].Label); FIO.WrLn(F);
   END;
   END;
 FIO.Close(F);
 IF RedNr>0 THEN
  FOR A:=0 TO RedNr-1 DO
   IO.WrStr("External: ");
   IO.WrStrAdj(Alias^[Red^[A].Label],-20);
   IO.WrChar("=");
   IO.WrStrAdj(Red^[A].HelpFile,-15);
   IO.WrChar("|");
   IO.WrStrAdj(Red^[A].ForeignLabel,-20);
   IO.WrLn;
   END;
  END;
 DisplayMem;
END HelpComp.