MODULE MySort;
(* DOS sort command clone, Demo belonging to XtdLib package,
          (C) by Marco van de Voort 1998

DOS sort command clone,  only I sort on another field than the first one :-)

Maximal 1000 lines of maximal 255 signs.

Sorts on a 25-character long case-insensitive string starting on column x.

Why? 4dos DIR, on column x starts the description.

Dir |mysort>ll sorts on description.
Doing so is easier (under 4DOS) with /oi, but this has other possibilities.

Anyway, by changing the tune variable you can sort on each column you want.

If you need more complex (more lines, bigger) sorting systems, you could look
at the cookie project. It has a sorter that (slightly changed) could also
sort files looking like Topspeeds helpfile (source) on each record.*)

IMPORT FIO,IO;
FROM Lib IMPORT Fill,QSort,Move;
FROM Str IMPORT Copy,Length,Compare,Slice,Caps,CHARSET;
FROM ELib IMPORT KillChar;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;

CONST Tune=25;                                  (* Sort on column x*)
      KillSet =CHARSET{"!","-",">","*"," "};   (* Before sorting, remove
                                                  trailing chars*)

TYPE TextStr= ARRAY[0..255] OF CHAR;
     TextRec= RECORD
               Len : BYTE;
               Txt : TextStr;
               END;
     TextPtr= POINTER TO TextRec;
     TextArr= ARRAY[0..999] OF TextPtr;

VAR F : FIO.File;
    S : ARRAY[0..255] OF CHAR;
    T : TextArr;
    I : CARDINAL;
    Nr : CARDINAL;

PROCEDURE CompareS(N1,N2:CARDINAL):BOOLEAN;

VAR S2,S3: ARRAY[0..25] OF CHAR;

BEGIN
 Slice(S2,T[N1-1]^.Txt,Tune,25);
 Slice(S3,T[N2-1]^.Txt,Tune,25);
 Caps(S3);Caps(S3);
 RETURN (Compare(S2,S3)<1);
END CompareS;

PROCEDURE SwapS(N1,N2:CARDINAL);

VAR TRec: TextRec;

BEGIN
 IF (N1<15000) AND (N2<15000) THEN
  Move (ADR(T[N1-1]^.Len), ADR(TRec),SIZE(TextRec));
  Move (ADR(T[N2-1]^.Len),ADR(T[N1-1]^.Len),SIZE(TextRec));
  Move (ADR(TRec),ADR(T[N2-1]^.Len),SIZE(TextRec));
  END;
END SwapS;

BEGIN
 F:=FIO.StandardInput;
 Fill(ADR(T),SIZE(TextArr),0);
 Nr :=0;
 LOOP
  FIO.RdStr(F,S);
  KillChar(S,KillSet);
  IF FIO.EOF THEN
   EXIT
   END;
  ALLOCATE(T[Nr],250); (* +1 for byte, +1 for CHR(0) *)
  T[Nr]^.Len:=BYTE(Length(S));
  Copy(T[Nr]^.Txt,S);
  INC(Nr);
  END;
 QSort(Nr,CompareS,SwapS);
 F:=FIO.StandardOutput;
 FOR I:=0 TO Nr-1 DO
  IO.WrStr(T[I]^.Txt);
  IO.WrLn
  END;
END MySort.