MODULE Palette1;
(*
Demo(more a gag) of module CorePal, XtdLib package

The "Stars" part I found in SWAG, so it isn't copyrighted.
The Modula-2 version however is :-)
I like my own (written from scratch) starfield more, check it out.

CoreCrt and CorePal are (C) Marco van de Voort 1996
*)

FROM CorePal IMPORT SetPalette,GetPalette,ColorBars;
FROM Crt     IMPORT TextColor,Color,GotoXY,ClrScr;
FROM Graph   IMPORT Plot,InitGraph,TextMode,GraphMode;
FROM Lib     IMPORT RANDOM,RANDOMIZE,Delay;
FROM IO      IMPORT WrCard,WrLn,WrStr,KeyPressed,RdKey;
FROM ELib    IMPORT GetKey;

TYPE
  rgb = RECORD
    r, g, b : BYTE;
  END;

VAR
  i   : CARDINAL;
  col : ARRAY[0..63] OF rgb;

PROCEDURE SetInten(b : CARDINAL);
VAR
  i      : CARDINAL;
  NP     : ARRAY[0..63] OF rgb;
  fr,  fg,  fb : BYTE;
BEGIN
  FOR i := 0 TO 63 DO
    NP[i].r := BYTE(CARDINAL(col[i].r) * CARDINAL(b) DIV 64);
    NP[i].g := BYTE(CARDINAL(col[i].g) * CARDINAL(b) DIV 64);
    NP[i].b := BYTE(CARDINAL(col[i].b) * CARDINAL(b) DIV 64);
    END;
   SetPalette(0,64, NP);
END SetInten;

PROCEDURE DoFade1;

BEGIN
  ClrScr;
  GetPalette(0,64,col);         (* Save current Palette *)
  FOR i := 1 TO 15 DO
    TextColor(Color(i));
    WrStr('Foreground colour = '); WrCard(i, 2); WrLn;
    END;
  i := GetKey();  (* Wait for a key *)
  FOR i := 63 TO 0 BY -1 DO  (* Decrease the intensity of the colors slowly*)
    SetInten(i);
    Delay(20);
  END;
  GotoXY(0, 0);
  FOR i := 15 TO 1 BY -1 DO  (* Reverse the order of the lines on screen
                         while invisible. (intensity 0 = black on black) *)
    TextColor(Color(i));
    WrStr('Foreground colour = '); WrCard(i, 2); WrLn;
    END;
  FOR i := 0 TO 63 DO   (* Increase the intensity of the colors slowly *)
    SetInten(i);
    Delay(20);
  END;
  i:=GetKey(); (* Wait for a key *)
END DoFade1;

(*---------------*)

CONST
  Steps = 75;
  DelayFactor = 60;

VAR
  Count, Count2 : CARDINAL;
  Pal1, Pal2 : ARRAY [0..255],[0..2] OF BYTE;

PROCEDURE FadeOut;
BEGIN
  FOR Count := 1 TO Steps DO
    FOR Count2 := 0 TO 255 DO
      IF Pal2 [Count2, 0] >BYTE( 0) THEN
        DEC (Pal2 [Count2, 0]);
        END;
      IF Pal2 [Count2, 1] > BYTE(0) THEN
        DEC (Pal2 [Count2, 1]);
        END;
      IF Pal2 [Count2, 2] > BYTE(0) THEN
        DEC (Pal2 [Count2, 2]);
        END;
    END;
    SetPalette(0,256,Pal2);
    Delay (DelayFactor);
  END;
END FadeOut;

PROCEDURE FadeIn;
BEGIN
  FOR Count := 1 TO Steps DO
    FOR Count2 := 0 TO 255 DO
      IF Pal2 [Count2, 0] < Pal1 [Count2, 0] THEN
        INC (Pal2 [Count2, 0]);
        END;
      IF Pal2 [Count2, 1] < Pal1 [Count2, 1] THEN
        INC (Pal2 [Count2, 1]);
        END;
      IF Pal2 [Count2, 2] < Pal1 [Count2, 2] THEN
        INC (Pal2 [Count2, 2]);
        END;
    END;
    SetPalette(0,256,Pal2);
    Delay (DelayFactor);
  END;
END FadeIn;

PROCEDURE DoFade2;
BEGIN
  GetPalette(0,256,Pal1);
  Pal2:=Pal1;
  FadeOut;
  FadeIn;
  SetPalette(0,256,Pal1);
END DoFade2;

(*---------------*)

TYPE Arr3B=ARRAY[0..2] OF BYTE;

CONST
  StarCol =Arr3B  (8, 7, 15);
  GetMaxX=640;
  GetMaxY=480;

TYPE
  StarRec = RECORD
    X,
    Y,
    D : CARDINAL;  (* depth *)
  END;

VAR
  stars : ARRAY[0..201] OF StarRec;
  xinc,
  yinc  : CARDINAL;
  ch    : CHAR;

PROCEDURE InitStars;
VAR
  i : CARDINAL;
BEGIN
  FOR i := 0 TO 201 DO
  WITH stars[i] DO
    X := RANDOM(GetMaxX);
    Y := RANDOM(GetMaxY);
    D := RANDOM(3);
    END;
  END;
END InitStars;

PROCEDURE MoveStars;
VAR
  i : CARDINAL;
BEGIN
  FOR i := 0 TO 201 DO
   WITH stars[i] DO
     Plot(X, Y, 0);
     X := X + xinc * (D + 1);
     IF (X < 0) THEN
       X := X + GetMaxX;
       END;
     IF (X > GetMaxX) THEN
       X := X - GetMaxX;
       Y:=RANDOM(GetMaxY);
       END;
     Y := Y + yinc * (D + 1);
     IF (Y < 0) THEN
       Y := Y + GetMaxY;
       END;
     IF (Y > GetMaxY) THEN
       Y := Y - GetMaxY;
       X:=RANDOM(GetMaxX);
       END;
     Plot(X, Y, CARDINAL(StarCol[D]));
   END;
  END;
END MoveStars;

PROCEDURE DoStars1;

BEGIN
  RANDOMIZE;
  InitGraph;  (* enter Graphics mode *)
  GraphMode;
  InitStars;
  xinc := 1;
  yinc := 0;
  REPEAT
    MoveStars;
    Delay(10);
    (* Delay here FOR faster computers *)
  UNTIL KeyPressed();
  ch := RdKey();
  IF (ch = CHR(0)) THEN
    ch := RdKey();  (* get rid OF extended keycodes *)
    END;
  TextMode;
END DoStars1;

(*---------------*)
VAR I : INTEGER;

BEGIN
 DoFade1;       (* Linear fade out, nicer but slower (in theori) *)
 DoFade2;       (* non-Linear fade out, uglier  but faster (in theori)  *)
 I:=GetKey();
 DoStars1;
END Palette1.
