MODULE Snow;
(*
Demo(more a gag) of module CorePal, XtdLib package

Since this demo originates from SWAG (can't remember who made it), no
copyright lies on this module.

CoreCrt and CorePal are (C) Marco van de Voort 1996*)

FROM Lib IMPORT RANDOMIZE,RANDOM,Delay;
FROM ELib IMPORT GetKey;
FROM CorePal IMPORT SetOne,SetPalette,SetBorder,VertRetrace;
FROM CoreCrt IMPORT SetCurSize,ChangeMode;

IMPORT IO;

CONST
  Dots =100;   (*Set this TO more than 100 AND the result is awful*)
  Flakes = 2000;            (* try less flakes FOR faster snowfall *)

TYPE
    (*# save *)
     (*#data(near_ptr => off) *)
     BytePtr= POINTER TO BYTE;
    (*# restore *)

     Arr24  = ARRAY[0..23] OF BYTE;
     ArrType= POINTER TO ARRAY[0..767] OF BYTE;

CONST Pal=Arr24(15,15,15,20,20,20,25,25,25,30,30,30,35,35,35,40,40,40,45,45,45,50,50,50);

PROCEDURE RandomCol ():BYTE;   (*Just a random value between 7 AND 15 (I think)*)
  BEGIN
    RETURN BYTE(RANDOM(6)+9);
  END RandomCol;

PROCEDURE PutPixel(x, y : CARDINAL; color : BYTE);
  BEGIN
    [0A000H:x+y*320 BytePtr]^ := color;
  END PutPixel;

PROCEDURE SetPixel(pixPos : CARDINAL; Color : BYTE);
BEGIN
    [0A000H:pixPos BytePtr]^ := Color;
END SetPixel;

PROCEDURE xf3(ux,t : REAL) : CARDINAL;   (*Calculates the speed OF a point*)
  BEGIN                             (*on the x axis*)
    RETURN TRUNC(ux*t)  +160;
  END xf3;

PROCEDURE yf3(uy,g,t : REAL) : CARDINAL; (*Calculates the speed OF a point*)
  VAR                               (*on the y axis (which is affected*)
    u,tmax,hmax : REAL;             (*by gravity)*)
    ym : ARRAY[1..200] OF CARDINAL;
    a  : CARDINAL;
  BEGIN
    u := uy-g*t;
    RETURN 200-TRUNC(uy*t-0.5*g*t*t);
  END yf3;

PROCEDURE SnowRout1;

VAR
  j,k : CARDINAL; (*INTEGER loop variables*)
  i : LONGINT;
  x,y : ARRAY[1..Dots] OF CARDINAL; (*Integer*)
  cols    : ARRAY[1..Dots] OF BYTE;
  f,g : CARDINAL;
  PalP : ArrType;

BEGIN
  RANDOMIZE;
  SetCurSize(0,32);
  j:=-(Dots) DIV 2;                  (*calculate the values OF the speed OF each dot*)
  FOR k:=1 TO Dots DO  (*WITH this loop*)
    INC(j,3);
    x[k]:=j;
    y[k]:=RANDOM(150);          (* if this value is to low, patterns
                                   will become visible *)
  END;
  FOR i:=1 TO Dots DO      (*Calculate the color OF each dot*)
    cols[CARDINAL(i)]:=RandomCol();
    END;
  ChangeMode(013H);
  FOR i:= 1 TO 63 DO
    SetOne(0,BYTE(i),BYTE(i),BYTE(i));
    END;
  PalP:=ADR(Pal);
  SetPalette(7,8,PalP^);
  FOR i:=1 TO 10 DO             (*the background color turns TO dark blue*)
   SetOne(0,0,0,BYTE(i));
   Delay(100);
   END;
  SetBorder(0);
  i:=18500;
  j:=1;
  REPEAT
    i:=i+1;
    FOR k:=1 TO Dots DO
      PutPixel(xf3(FLOAT(x[k]),0.01*FLOAT(i)),
                  yf3(FLOAT(y[k]),FLOAT(j),0.01*FLOAT(i)),cols[k]);
      END;
    VertRetrace;
    FOR k:=1 TO Dots DO
      PutPixel(xf3(FLOAT(x[k]),0.01*FLOAT(i)),yf3(FLOAT(y[k]),FLOAT(j),0.01*FLOAT(i)),0);
      END;
  UNTIL IO.KeyPressed();
  ChangeMode(3);
  f:=GetKey();
END SnowRout1;

PROCEDURE SnowRout2;

VAR
  CurFlake     : CARDINAL;                        (* snowflake counter *)
  xx,yy, newPos: ARRAY[0..Flakes] OF CARDINAL;         (* lookup tables *)
  i            : LONGINT;
  A            : CARDINAL;
BEGIN
  RANDOMIZE;
  FOR CurFlake:=0 TO Flakes DO        (* set up snow lookup table *)
    xx[CurFlake]:=RANDOM(319)+1;
    yy[CurFlake]:=RANDOM(199)+1;
  END;

  ChangeMode(13H);                       (* 320x200x256 graphics mode *)

  i := 0; (* change TO 100 OR higher TO get rid OF start explosion *)

  REPEAT
    INC(i);
    FOR CurFlake:=0 TO Flakes DO
        SetPixel(newPos[CurFlake], 0);     (* erase old snowflake *)
        newPos[CurFlake] :=      (* set up AND draw new snowflake *)
          CARDINAL(i*LONGINT(xx[CurFlake]) DIV 100) +
          CARDINAL(i*LONGINT(yy[CurFlake]) DIV 100) * 320;        (* new Y *)
        SetPixel(newPos[CurFlake], BYTE(CurFlake MOD 13) + BYTE(19));
      END;
    VertRetrace;
  UNTIL IO.KeyPressed();
  ChangeMode(03H);                       (* return TO 80x25 textmode *)
END SnowRout2;

BEGIN
 SnowRout1;
 SnowRout2;
END Snow.
