MODULE Voxel;
(* I found the pascal version of this source in Pascal.028, but since I don't
    have the message anymore, I don't know who owns the credits.
    I think it's Bas van Gaalen, but I'm not entirely sure.
    Since the pascal version was public domain, so is this.
    The libraries CoreCrt, CorePal and ELib whoever are mine and NOT PD.
    Translation to Modula-2 by Marco van de Voort, added the (lousy)
    colorcycling and displaying the plasma. Sorry, couldn't find a nicer
    palette (changing color more gradually)

    Remember, in the second part of the demo (with the green on the screen)
    you can move with the arrows!!!!!!!!!

    Needs a Mode-X update, since 320x200 is a little bit rough.
    *)

FROM Lib IMPORT RANDOM,RANDOMIZE,Fill,FarWordMove,Delay,FarMove;
FROM MATHLIB IMPORT Cos,Sin;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
FROM CoreCrt IMPORT ChangeMode;
FROM CorePal IMPORT SetPalette,PalP;
FROM ELib    IMPORT GetKey;

IMPORT IO;

TYPE LrgArr     =       ARRAY[0..65534] OF BYTE;
     HalfPal    =       ARRAY[0..383] OF BYTE;

CONST
  Pal= HalfPal(
  0,0,0,48,48,48,1,0,43,1,3,43,2,5,44,2,7,44,3,9,45,4,11,46,5,13,47,6,15,48,
  7,17,49,8,19,50,9,21,51,10,22,52,11,24,52,12,26,54,13,28,54,14,30,56,15,32,
  56,16,34,58,17,34,58,17,36,58,18,38,60,19,40,60,20,42,62,21,44,62,10,31,0,
  11,31,0,11,31,1,11,32,1,12,32,1,12,32,2,12,33,2,13,33,2,14,33,3,15,33,3,15,
  34,3,15,34,4,15,35,4,16,35,4,16,35,5,16,36,5,17,36,5,17,36,6,18,37,6,18,38,
  7,19,38,8,20,39,8,20,40,9,21,40,10,22,41,10,22,42,11,23,42,12,24,43,12,24,
  44,13,25,44,14,25,45,14,26,46,15,27,46,16,27,47,17,28,47,18,28,48,19,29,49,
  19,30,49,20,30,50,21,31,51,21,32,51,22,32,52,23,33,53,23,34,53,24,34,54,25,
  35,55,25,36,55,26,36,56,27,37,57,27,38,57,27,39,57,27,41,57,27,42,57,27,43,
  57,27,44,57,27,45,57,27,46,57,27,47,57,27,49,57,27,50,57,27,51,57,27,52,57,
  27,53,57,27,55,57,27,56,57,27,57,57,27,58,57,27,58,57,26,58,57,25,58,57,24,
  58,56,23,58,55,22,58,54,20,58,53,19,58,51,18,58,50,17,58,50,16,58,49,15,58,
  48,14,58,47,13,58,46,12,58,45,11,58,44,11,58,44,10,58,43,10,58,42,9,57,41,
  8,57,40,8,56,39,7,56,38,6,55,37,5,55,35,4,54,33,4,54,31,2,32,32,32,63,63,63,
  63,63,63,63,63,63,63,63,63,48,48,48,63,63,63,63,63,63);

CONST Pi=REAL(3.1415);

VAR
  MP,Scr: POINTER TO LrgArr;
  Rng:ARRAY[0..320] OF BYTE;
  Dir,i,x,y:INTEGER;

PROCEDURE NCol(mc,n,dvd:INTEGER):INTEGER;
VAR Loc:INTEGER;
BEGIN
  Loc:=(mc+n-INTEGER(RANDOM(2*n))) DIV dvd;
  IF Loc>250 THEN
   Loc:=250;
   END;
  IF Loc<5 THEN
   Loc:=5
   END;
  RETURN Loc;
END NCol;

PROCEDURE Plasma(x1,y1,x2,y2:CARDINAL);
VAR xn,yn,dxy,P1,P2,P3,P4:CARDINAL;
BEGIN
  IF (x2-x1<2) AND (y2-y1<2) THEN
   RETURN;
   END;
  P1:=CARDINAL(MP^[256*y1+x1]); P2:=CARDINAL(MP^[256*y2+x1]);
  P3:=CARDINAL(MP^[256*y1+x2]); P4:=CARDINAL(MP^[256*y2+x2]);
  xn:=(x2+x1) >> 1; yn:=(y2+y1) >> 1;
  dxy:=5*(x2-x1+y2-y1) DIV 3;
  IF MP^[256*y1+xn]=BYTE(0) THEN
   MP^[256*y1+xn]:=BYTE(NCol(P1+P3,dxy,2));
   END;
  IF MP^[256*yn+x1]=BYTE(0) THEN
   MP^[256*yn+x1]:=BYTE(NCol(P1+P2,dxy,2));
   END;
  IF MP^[256*yn+x2]=BYTE(0) THEN
   MP^[256*yn+x2]:=BYTE(NCol(P3+P4,dxy,2));
   END;
  IF MP^[256*y2+xn]=BYTE(0) THEN
   MP^[256*y2+xn]:=BYTE(NCol(P2+P4,dxy,2));
   END;
  MP^[256*yn+xn]:=BYTE(NCol(P1+P2+P3+P4,dxy,4));
  Plasma(x1,y1,xn,yn); Plasma(xn,y1,x2,yn);
  Plasma(x1,yn,xn,y2); Plasma(xn,yn,x2,y2);
END Plasma;

PROCEDURE Draw(xp,yp,Dir:INTEGER);
VAR z,zobs,ix,iy,iy1,iyp,ixp,x,y,s,csf,snf,MPc,i,j:INTEGER;
BEGIN
  Fill(ADR(Rng),SIZE(Rng),200); zobs:=100+INTEGER(MP^[256*yp+xp]);
  csf:=TRUNC(256.0*REAL(Cos(LONGREAL(REAL(Dir)/180.0*Pi))));
  snf:=TRUNC(256.0*REAL(Sin(LONGREAL(REAL(Dir)/180.0*Pi))));
  Fill(ADR(Scr^),64000,0);
  FOR iy:=yp TO yp+55 DO
    iy1:=1+2*(iy-yp); s:=4+300 DIV iy1;
    FOR ix:=xp+yp-iy TO xp-yp+iy DO
      ixp:=xp+((ix-xp)*csf+(iy-yp)*snf) >> 8;
      iyp:=yp+((iy-yp)*csf-(ix-xp)*snf) >> 8;
      x:=160+360*(ix-xp) DIV iy1;
      IF (x>=0) AND (x+s<=318) THEN
        z:=INTEGER(MP^[iyp << 8+ixp]); MPc:=z >> 1;
        IF z<47 THEN
         z:=46;
         END;
        y:=100+(zobs-z)*30 DIV iy1;
        IF (y<=199) AND (y>=0) THEN
         FOR j:=x TO x+s DO
          FOR i:=y TO INTEGER(Rng[j]) DO
           Scr^[320*i+j]:=BYTE(MPc);
           END;
          IF BYTE(y)<Rng[j] THEN
           Rng[j]:=BYTE(y)
           END;
          END;
        END;
      END;
    END;
  END;
  FarWordMove(FarADR(Scr^),[0A000H:0],32000);
END Draw;

VAR A              : CARDINAL;
    FakePtr,Fake2,
    ExtrPal       : PalP;

BEGIN
  NEW(ExtrPal);
  FOR A :=0 TO 63 DO
   ExtrPal^[A].Red:=BYTE(A);
   ExtrPal^[A].Green:=0;
   ExtrPal^[A].Blue:=0;
   ExtrPal^[A+64].Red:=BYTE(63-A);
   ExtrPal^[A+64].Green:=BYTE(A);
   ExtrPal^[A+64].Blue:=0;
   ExtrPal^[A+128].Red:=0;
   ExtrPal^[A+128].Green:=BYTE(63-A);
   ExtrPal^[A+128].Blue:=BYTE(A);
   ExtrPal^[A+192].Red:=0;
   ExtrPal^[A+192].Green:=0;
   ExtrPal^[A+192].Blue:=BYTE(63-A);;
   END;
  IO.WrStr('creating landscape...'); IO.WrLn;
  RANDOMIZE; x:=0; y:=0; Dir:=0; NEW(MP); Fill(ADR(MP^),65535,0);
  NEW(Scr); MP^[0]:=128; Plasma(0,0,256,256);
  ChangeMode(013H);
  FakePtr:=ADR(Pal);
(*  FakePtr:=ExtrPal; *)
  SetPalette(0,128,FakePtr^);
  FOR A:= 0 TO 199 DO
   FarMove(FarADR(MP^[A*256]),[0A000H:A*320],257);
   END;
  A:=0;
  WHILE NOT IO.KeyPressed() DO
   INC(A);
   IF A=128 THEN A:=0; END;
   Fake2:=ADR(FakePtr^[128-A]);
   SetPalette(0,128-A,Fake2^);
   SetPalette(128,128-A,Fake2^);
   IF A # 0 THEN
    SetPalette(128-A,A,FakePtr^);
    SetPalette(256-A,A,FakePtr^);
    END;
   Delay(10);
   END;
  SetPalette(0,128,FakePtr^);  SetPalette(128,128,FakePtr^);
  A:=CARDINAL(IO.RdKey());
  REPEAT
    Dir:=Dir MOD 360;
    Draw(x,y,Dir);
    A:=GetKey();
    CASE A OF
     | 19200 : DEC(Dir,10);
     | 19712 : INC(Dir,10);
     | 18432 : INC(y,TRUNC(5.0*REAL(Cos(LONGREAL(REAL(Dir)/180.0*Pi)))));
               INC(x,TRUNC(5.0*REAL(Sin(LONGREAL(REAL(Dir)/180.0*Pi)))));
     | 20480 : DEC(y,TRUNC(5.0*REAL(Cos(LONGREAL(REAL(Dir)/180.0*Pi)))));
               DEC(x,TRUNC(5.0*REAL(Sin(LONGREAL(REAL(Dir)/180.0*Pi)))));
    END
  UNTIL A=27;
  ChangeMode(3);
END Voxel.
